package dk.dionysus.hjarl;

import java.io.IOException;

import javax.microedition.khronos.opengles.GL10;

import dk.dionysus.hjarl.Controls;
import dk.dionysus.hjarl.Highscore;
import dk.dionysus.hjarl.Options;
import me.trifunovic.spaceassault.game.hud.HudScore;

import org.anddev.andengine.audio.music.Music;
import org.anddev.andengine.audio.music.MusicFactory;
import org.anddev.andengine.audio.sound.Sound;
import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.camera.hud.HUD;
import org.anddev.andengine.engine.camera.hud.controls.AnalogOnScreenControl;
import org.anddev.andengine.engine.camera.hud.controls.DigitalOnScreenControl;
import org.anddev.andengine.engine.camera.hud.controls.AnalogOnScreenControl.IAnalogOnScreenControlListener;
import org.anddev.andengine.engine.camera.hud.controls.BaseOnScreenControl;
import org.anddev.andengine.engine.handler.IUpdateHandler;
import org.anddev.andengine.engine.handler.physics.PhysicsHandler;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.primitive.Rectangle;
import org.anddev.andengine.entity.scene.CameraScene;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.Scene.IOnAreaTouchListener;
import org.anddev.andengine.entity.scene.Scene.ITouchArea;
import org.anddev.andengine.entity.scene.background.ColorBackground;
import org.anddev.andengine.entity.shape.Shape;
import org.anddev.andengine.entity.sprite.AnimatedSprite;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.entity.sprite.TiledSprite;
import org.anddev.andengine.entity.sprite.batch.SpriteGroup;
import org.anddev.andengine.entity.text.ChangeableText;
import org.anddev.andengine.entity.util.FPSCounter;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.extension.physics.box2d.FixedStepPhysicsWorld;
import org.anddev.andengine.extension.physics.box2d.PhysicsConnector;
import org.anddev.andengine.extension.physics.box2d.PhysicsFactory;
import org.anddev.andengine.extension.physics.box2d.PhysicsWorld;
import org.anddev.andengine.extension.physics.box2d.util.Vector2Pool;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.ui.activity.BaseGameActivity;
import org.anddev.andengine.util.Debug;
import org.anddev.andengine.util.MathUtils;

import android.graphics.Color;
import android.graphics.Typeface;
import android.view.KeyEvent;
import android.widget.Toast;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.BodyDef.BodyType;
import com.badlogic.gdx.physics.box2d.FixtureDef;

import org.anddev.andengine.extension.input.touch.controller.MultiTouch;
import org.anddev.andengine.extension.input.touch.controller.MultiTouchController;
import org.anddev.andengine.extension.input.touch.exception.MultiTouchException;

/**
 * (c) 2010 Nicolas Gramlich
 * (c) 2011 Zynga
 *
 * @author Nicolas Gramlich
 * @since 22:43:20 - 15.07.2010
 * 
 * @author Kasper Olesen
 * @since 18:29:20 - 19.12.2011
 */

public class HjarlGameActivity  extends BaseGameActivity {
	// ===========================================================
	// Constants
	// ===========================================================

	private static final int CAMERA_WIDTH = 640;
	private static final int CAMERA_HEIGHT = 480;
	
	private static final int DIALOG_ALLOWDIAGONAL_ID = 0;

	// ===========================================================
	// Fields
	// ===========================================================

	private Camera mCamera;

	private BitmapTextureAtlas mTexture;
	private TiledTextureRegion mHjarlTextureRegion;
	private TextureRegion mBox1TextureRegion;
	private TextureRegion mBox2TextureRegion;
	private TextureRegion mBox3TextureRegion;
	private TextureRegion mHardware1TextureRegion;
	private TextureRegion mHardware2TextureRegion;
	private TextureRegion mHardware3TextureRegion;
	private TextureRegion mVanTextureRegion;
	
	// Buttons
	private TextureRegion MusicButtonTextureRegion;
	private TextureRegion SoundButtonTextureRegion;
	private TextureRegion PauseButtonTextureRegion;
	

	// Stuff
	private BitmapTextureAtlas mBoxTexture;
	private TextureRegion mBoxTextureRegion;

	private BitmapTextureAtlas BackgroundTexture;
	private TextureRegion BackgroundTextureRegion;

	private BitmapTextureAtlas mOnScreenControlTexture;
	private TextureRegion mOnScreenControlBaseTextureRegion;
	private TextureRegion mOnScreenControlKnobTextureRegion;
	final boolean ControlLocked = false;
	private DigitalOnScreenControl mDigitalOnScreenControl;
	
	// scene
	private TextureRegion mPausedTextureRegion;
	private CameraScene mPauseScene;

	static Scene mScene;
	
	
	// HUD Text and HUD
    private BitmapTextureAtlas mFontTexture;
    private BitmapTextureAtlas mFontTexture2;
    private Font mFont;
    private Font mFontTiny;
    HUD hud = new HUD();

	//private static PhysicsWorld mPhysicsWorld;
	private PhysicsWorld mPhysicsWorldg;
	
	
    /* The categories. */
	public final static short CATEGORYBIT_WALL         		=  1;
	public final static short CATEGORYBIT_WALL_AIR    		=  2;
    public final static short CATEGORYBIT_PLAYER       		=  4;
    public final static short CATEGORYBIT_UNGUIDROCKET 		=  8;
    public final static short CATEGORYBIT_OBJECT       		= 32;
    
	 public final static short MASKBITS_UNGUIDROCKET = CATEGORYBIT_WALL + CATEGORYBIT_OBJECT;
	public final static FixtureDef UNGUIDROCKET_FIXTURE_DEF = PhysicsFactory.createFixtureDef( 300f, 1.0f,999.0f, false, CATEGORYBIT_UNGUIDROCKET, MASKBITS_UNGUIDROCKET, (short)0);
	

	
	private Body mJarlBody;
	private TiledSprite mJarl;
	final Rectangle grabRectangle = new Rectangle(16, 80, 96, 32);
	PhysicsHandler physicsHandler;
	
	private Body mHardwareBody[];
	//private Body HardwareBody;
	
	private Sprite Hardware;

	
	private Sprite mHardware[];
	private boolean hwactive[];
	int zIndex = 0;

	public static final HudScore score = new HudScore();
	public static Options options;
	public static Controls controls;
	public static Sprite Button;
	
	private Sprite sound;
	private Sprite music;
	private Music mMusic;
	static boolean Sound;
	
	private Sprite control[];
	float ControlX[];
	float ControlY[];
	float scale[];
	int ControlKeyAction1[], ControlKeyAction2[], ControlKeyAction3[], ControlKeyAction4[];
	int JarlAction = 0;

	
	// ===========================================================
	// Constructors
	// ===========================================================

	// ===========================================================
	// Getter & Setter
	// ===========================================================


	
	// ===========================================================
	// Methods for/from SuperClass/Interfaces
	// ===========================================================

	@Override
	public Engine onLoadEngine() {
		options = new Options(HjarlGameActivity.this);
		controls = new Controls(HjarlGameActivity.this);
		
		this.mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
		mCamera.setHUD(this.hud);
		
		final Engine engine = new Engine(new EngineOptions(true, ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT), this.mCamera).setNeedsMusic(true).setNeedsSound(true));
		
		try {
			if(MultiTouch.isSupported(this)) {
				engine.setTouchController(new MultiTouchController());
				if(MultiTouch.isSupportedDistinct(this)) {
					//Toast.makeText(this, "MultiTouch detected --> Drag multiple Sprites with multiple fingers!", Toast.LENGTH_LONG).show();
				} else {
					Toast.makeText(this, "MultiTouch detected --> Drag multiple Sprites with multiple fingers!\n\n(Your device might have problems to distinguish between separate fingers.)", Toast.LENGTH_LONG).show();
				}
			} else {
				Toast.makeText(this, "Sorry your device does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)", Toast.LENGTH_LONG).show();
			}
		} catch (final MultiTouchException e) {
			Toast.makeText(this, "Sorry your Android Version does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)", Toast.LENGTH_LONG).show();
		}
		
		
		return engine;
	}

	@Override
	public void onLoadResources() {
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");

		this.mTexture = new BitmapTextureAtlas(1024, 1024, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mHjarlTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.mTexture, this, "jarl.png", 0, 0, 5, 1);
		this.mBox1TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "kasse_cpu.png", 220, 0);
		this.mBox2TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "kasse_gfx.png", 220, 123);
		this.mBox3TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "kasse_ram.png", 220, 250);
		this.mHardware1TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "obj_cpu.png", 366, 128);
		this.mHardware2TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "obj_gfx.png", 366, 188);
		this.mHardware3TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "obj_ram.png", 366, 256);
		
        this.mFontTexture = new BitmapTextureAtlas(128, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
        this.mFontTexture2 = new BitmapTextureAtlas(128, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mFont = new Font(this.mFontTexture, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 16, true, Color.WHITE);
        this.mFontTiny = new Font(this.mFontTexture2, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 12, true, Color.WHITE);
        
		this.mVanTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "van.png", 366, 281);
		
		
		this.MusicButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "buttons/MusicButton.png", 366, 0);
		this.SoundButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "buttons/SoundButton.png", 412, 0);
		this.mPausedTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mTexture, this, "buttons/PAUSE.png", 220, 400);
		

		this.BackgroundTexture = new BitmapTextureAtlas(1024, 1024, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.BackgroundTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.BackgroundTexture, this, "baggrund.jpg", 0, 0);
		//this.mRacetrackCurveTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mRacetrackTexture, this, "racetrack_curve.png", 0, 128);

		this.mOnScreenControlTexture = new BitmapTextureAtlas(256, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mOnScreenControlBaseTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_base.png", 0, 0);
		this.mOnScreenControlKnobTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_knob.png", 128, 0);

		this.mBoxTexture = new BitmapTextureAtlas(32, 32, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mBoxTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBoxTexture, this, "box.png", 0, 0);
		
		MusicFactory.setAssetBasePath("mfx/");
		try {
			this.mMusic = MusicFactory.createMusicFromAsset(this.mEngine.getMusicManager(), this, "wagner_the_ride_of_the_valkyries.ogg");
			this.mMusic.setLooping(true);
		} catch (final IOException e) {
			Debug.e(e);
		}
		
		
		

		this.mEngine.getTextureManager().loadTextures(this.mTexture, this.BackgroundTexture, this.mOnScreenControlTexture, this.mBoxTexture, this.mFontTexture, this.mFontTexture2);
		
		this.mEngine.getFontManager().loadFont(this.mFont);
		this.mEngine.getFontManager().loadFont(this.mFontTiny);
		
	}

	@Override
	public Scene onLoadScene() {
		this.mEngine.registerUpdateHandler(new FPSLogger());

		HjarlGameActivity.mScene = new Scene();
		HjarlGameActivity.mScene.setBackground(new ColorBackground(0, 0, 0));

		this.mPauseScene = new CameraScene(this.mCamera);
		/* Make the 'PAUSED'-label centered on the camera. */
		final Sprite pausedSprite = new Sprite(CAMERA_WIDTH / 2 - this.mPausedTextureRegion.getWidth() / 2, CAMERA_HEIGHT / 2 - this.mPausedTextureRegion.getHeight() / 2, this.mPausedTextureRegion);
		this.mPauseScene.attachChild(pausedSprite);
		/* Makes the paused Game look through. */
		this.mPauseScene.setBackgroundEnabled(false);
		
		//this.setmPhysicsWorld(new FixedStepPhysicsWorld(30, new Vector2(0, 0), false, 8, 1));
		this.mPhysicsWorldg = new FixedStepPhysicsWorld(30, new Vector2(0, 10), true, 10, 10);
		

		this.initBackground();
		this.initBorders();
		this.initJarl();
		this.initHardware();
		
		physicsHandler = new PhysicsHandler(mJarl);
		mJarl.registerUpdateHandler(physicsHandler);
		
		control = new Sprite[10];
		ControlX = new float[10];
		ControlY = new float[10];
		scale = new float[10];
		ControlKeyAction1 = new int[10];
		ControlKeyAction2 = new int[10];
		ControlKeyAction3 = new int[10];
		ControlKeyAction4 = new int[10];
		
		for (int i = 0; i < 10; i++) {
			int s = 64;
			if (i < 4) s = 128;
			scale[i] = controls.getScale(i);
			
			ControlX[i] = controls.getX(i) * (CAMERA_WIDTH - s * scale[i]) / 100;;
			
			ControlY[i] = controls.getY(i) / 100 * (CAMERA_HEIGHT - s * scale[i]);
			
			ControlY[i] = ControlY[i] - s * (1 - scale[i]);
			
			ControlKeyAction1[i] = controls.getKey(i, 1);
			ControlKeyAction2[i] = controls.getKey(i, 2);
			ControlKeyAction3[i] = controls.getKey(i, 3);
			ControlKeyAction4[i] = controls.getKey(i, 4);
			
		}
		
		
		this.initOnScreenControls();
		
		/* UI */
		
		final int x = (CAMERA_WIDTH - this.MusicButtonTextureRegion.getWidth()* 2);
		final int y = 0;

		
		this.music = new Sprite(x, y, this.MusicButtonTextureRegion) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {	
				if(pSceneTouchEvent.isActionDown()) {
					if(HjarlGameActivity.this.mMusic.isPlaying()) {
						HjarlGameActivity.this.mMusic.pause();
						this.setColor(1, 1, 1);
						this.setScale(1);
					} else {
						HjarlGameActivity.this.mMusic.play();
						this.setColor(0.7f, 0.7f, 0.7f);
						this.setScale(0.9f);
					}
				}

				return true;
			}
		};

		hud.attachChild(music);
		hud.registerTouchArea(music);
		
		this.sound = new Sprite(x - this.SoundButtonTextureRegion.getWidth() * 2, y, this.SoundButtonTextureRegion) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {	
				if(pSceneTouchEvent.isActionDown()) {
					if(this.getRed() == 0.7f) {
						HjarlGameActivity.Sound = false;
						this.setColor(1, 1, 1);
						this.setScale(1);
					} else {
						HjarlGameActivity.Sound = true;
						this.setColor(0.7f, 0.7f, 0.7f);
						this.setScale(0.9f);
					}
				}

				return true;
			}
		};

		hud.attachChild(sound);
		hud.registerTouchArea(sound);



		
        // Initiate FPS counter
        final FPSCounter fpsCounter = new FPSCounter();
        this.mEngine.registerUpdateHandler(fpsCounter);
        
        final ChangeableText fpsText = new ChangeableText(5, 5, this.mFont, "FPS:", "FPS: XXXXXX X: XXXXX Y: XXXXXXX TX: XXXXXX TY: XXXXXXX".length());
        // Attach FPS counter to HUD
        mScene.attachChild(fpsText);
		
		final Shape crash = new Rectangle(0, 420, CAMERA_WIDTH, 20);
		HjarlGameActivity.mScene.attachChild(crash);
		crash.setColor(0, 0, 0);
		/************** The actual collision-checking. **********************/
		mScene.registerUpdateHandler(new IUpdateHandler() {
			@Override
			public void reset() { }

			@Override
			public void onUpdate(final float pSecondsElapsed) {
				
				fpsText.setText("FPS: " + Math.round(fpsCounter.getFPS()) //+ " Y: " + Math.round(mHardware[0].getY()) + " X: " + Math.round(mHardware[0].getX())
						);
				
				
				for (int i = 0; i < 10; i++) {
				
				
				if (hwactive[i])
				if(mJarl.collidesWith(mHardware[i])) {
					/*this.mPhysicsWorldg.unregisterPhysicsConnector(facePhysicsConnector);
					this.mPhysicsWorldg.destroyBody(facePhysicsConnector.getBody());

					this.mScene.unregisterTouchArea(mHardware[i]);
					this.mScene.detachChild(mHardware[i]);*/
					mJarl.setColor(1, 0, 0);
				} else {
					mJarl.setColor(1, 1, 1);
				}
				
				if (hwactive[i])
				if(crash.collidesWith(mHardware[i])) {
					mHardware[i].setColor(0, 0, 1);
				} else {
					mHardware[i].setColor(1, 1, 1);
				}
				
				if(crash.collidesWith(mHardware[i])){
					crash.setColor(1, 0, 0);
					//HjarlGameActivity.this.mPhysicsWorldg.destroyBody(mHardwareBody[i]);
					
					
					destroyHardware(mHardware[i]);
					
					/*
					final PhysicsConnector mphysicsConnector = HjarlGameActivity.this.mPhysicsWorldg.getPhysicsConnectorManager().findPhysicsConnectorByShape(mHardware[i]);
					mPhysicsWorldg.unregisterPhysicsConnector(mphysicsConnector);
					*/
					//mPhysicsWorldg.unregisterPhysicsConnector(new PhysicsConnector(mHardware[i], mHardwareBody[i], true, true));
					//mScene.detachChild(mHardware[i]);
					//HjarlGameActivity.this.mPhysicsWorldg.destroyBody(mHardwareBody[i]);
					//HjarlGameActivity.this.mPhysicsWorldg.clearPhysicsConnectors();
					//HjarlGameActivity.this.mPhysicsWorldg.destroyBody(mHardwareBody[i]);

					//System.gc();
					//hwactive[i] = false;
				} else {
					
				}
				
				if (hwactive[i])
				if(grabRectangle.collidesWith(mHardware[i])){
					Hardware.setColor(0, 0, 0);
					grabRectangle.setColor(0, 1, 0);
					grabRectangle.setAlpha(0.5f);
					mScene.detachChild(mHardware[i]);
					grabRectangle.attachChild(mHardware[i]);
				}
				
				
				}
			}
		});
		
		//HjarlGameActivity.mScene.registerUpdateHandler(HjarlGameActivity.getmPhysicsWorld());
		HjarlGameActivity.mScene.registerUpdateHandler(this.mPhysicsWorldg);
		
		return HjarlGameActivity.mScene;
	}

	@Override
	public void onLoadComplete() {

	}

	// ===========================================================
	// Methods
	// ===========================================================

	private void initOnScreenControls() {
		
		Controls controls = new Controls(HjarlGameActivity.this);
		
		Highscore score = new Highscore(HjarlGameActivity.this);
		
		
		/*
		float ControlX = controls.getX(0);
		float ControlY = controls.getY(0);
		float ControlSize = controls.getScale(0);
		*/
		
		
		
		// Toast for debugging
		Toast.makeText(HjarlGameActivity.this, "Scale:" + scale[0], Toast.LENGTH_SHORT).show();
		
		//ControlX = 0;
		//ControlY = CAMERA_HEIGHT - this.mOnScreenControlBaseTextureRegion.getHeight() - ControlY;
		//ControlSize = 75; 

		final DigitalOnScreenControl digitalOnScreenControl = new DigitalOnScreenControl(ControlX[0], ControlY[0], this.mCamera, this.mOnScreenControlBaseTextureRegion, this.mOnScreenControlKnobTextureRegion, 0.1f, new IAnalogOnScreenControlListener() {
			@Override
			public void onControlChange(final BaseOnScreenControl pBaseOnScreenControl, float pValueX, final float pValueY) {

				// final Body JarlBody = HjarlGameActivity.this.mJarlBody;
				
				//Vector2 velocity = Vector2Pool.obtain(0, 0);
				if (mJarl.getX() < 25 && pValueX < 0) {
					pValueX = 0;
					mJarl.setPosition(50,mJarl.getY());
					
				}

				if (mJarl.getX() > 550 && pValueX > 0) {
					pValueX = 0;
					mJarl.setPosition(500,mJarl.getY());
				}
				
				if (JarlAction == 4) pValueX = 1;
				if (JarlAction == 6) pValueX = -1;
				
				if (mJarl.getX() < 50 && pValueX < 0) pValueX = 0;
				//if (mJarl.getX() > 100 && mJarl.getX() < 400) pValueX = 0;
				if (mJarl.getX() > 500 && pValueX > 0) pValueX = 0;
				
				
				
				// velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
				
				// JarlBody.setLinearVelocity(velocity);
				// Vector2Pool.recycle(velocity);

				// final float rotationInRad = (float)Math.atan2(-pValueX, pValueY);
				// JarlBody.setTransform(JarlBody.getWorldCenter(), rotationInRad);

				//HjarlGameActivity.this.mJarl.setRotation(MathUtils.radToDeg(rotationInRad));


				physicsHandler.setVelocity(pValueX * 250, pValueY * 0);
			}

			@Override
			public void onControlClick(final AnalogOnScreenControl pAnalogOnScreenControl) {
				/* Nothing. */
			}
		});
		digitalOnScreenControl.getControlBase().setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		digitalOnScreenControl.getControlBase().setAlpha(0.5f);
		digitalOnScreenControl.getControlBase().setScaleCenter(0, 128);
		
		// Toast for debugging
		//Toast.makeText(HjarlGameActivity.this, "Scale:" + size, Toast.LENGTH_SHORT).show();
		//size = 0.75f;
		
		digitalOnScreenControl.getControlBase().setScale(scale[0]);
		digitalOnScreenControl.getControlKnob().setScale(scale[0]);
		
		digitalOnScreenControl.refreshControlKnobPosition();

		this.hud.setChildScene(digitalOnScreenControl);
		
		
		HjarlGameActivity.Button = new Sprite(ControlX[5], ControlY[5], this.mOnScreenControlKnobTextureRegion) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {	
				if(pSceneTouchEvent.isActionDown()) {
					if(this.getRed() == 0.7f) {
						this.setColor(1, 1, 1);
						this.setScale(scale[5]);
						
						/*if(HjarlGameActivity.BULLETPOOL.getUnrecycledCount() < 10)
						{
							final BulletSprite bulletSprite = HjarlGameActivity.BULLETPOOL.obtainPoolItem();
							
							
							bulletSprite.set(100, 100, 10, 40, MathUtils.degToRad(90));
							//Main.this.mEngine.vibrate(10);
						}*/
						//Vector2Pool.recycle(velocityPlayer);
						
					} else {
						this.setColor(0.7f, 0.7f, 0.7f);
						this.setScale(scale[5] * 0.9f);
						HjarlGameActivity.this.throwHardware(CAMERA_WIDTH + 5, CAMERA_HEIGHT / 2);
					}
				}

				return true;
			}
		};

		hud.attachChild(Button);
		hud.registerTouchArea(Button);
	}

	private void initJarl() {
		this.mJarl = new TiledSprite(100, CAMERA_HEIGHT / 3, this.mHjarlTextureRegion);
		this.mJarl.setCurrentTileIndex(0);

		//final FixtureDef carFixtureDef = PhysicsFactory.createFixtureDef(50, 0.0f, 0.0f);
		//this.mJarlBody = PhysicsFactory.createBoxBody(this.mPhysicsWorld, this.mJarl, BodyType.DynamicBody, carFixtureDef);

		//this.mPhysicsWorld.registerPhysicsConnector(new PhysicsConnector(this.mJarl, this.mJarlBody, true, false));

		HjarlGameActivity.mScene.attachChild(this.mJarl);
		
		final PhysicsHandler physicsHandler = new PhysicsHandler(mJarl);
		mJarl.registerUpdateHandler(physicsHandler);
		
		/* Create A spinning rectangle and a line. */

		

		//centerRectangle.registerEntityModifier(entityModifier);
		grabRectangle.setColor(0,0,1);
		grabRectangle.setAlpha(55);
		mJarl.attachChild(grabRectangle);
		
	}

	private void initHardware() {

		
		
		final Sprite box1 = new Sprite(64, CAMERA_HEIGHT / 3 * 2, this.mBox1TextureRegion);
		final Sprite box2 = new Sprite(224, CAMERA_HEIGHT / 3 * 2, this.mBox2TextureRegion);
		final Sprite box3 = new Sprite(384, CAMERA_HEIGHT / 3 * 2, this.mBox3TextureRegion);
		final Sprite van = new Sprite(CAMERA_WIDTH - mVanTextureRegion.getWidth(), CAMERA_HEIGHT / 4, this.mVanTextureRegion);
		

		
		mHardware = new Sprite[10];
		mHardwareBody = new Body[10];
		hwactive = new boolean[10];
		
		
		for (int i = 0; i < 10; i++) {
			hwactive[i] = false;
		}
		/* don't activate the hardware arrays
		for (int i = 0; i < 10; i++) {
			int r = (int) Math.round(Math.random() * 3);
			//mHardware[i] = new Sprite(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2, this.mHardware1TextureRegion);
			if(r > 2) mHardware[i] = new Sprite(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2, this.mHardware1TextureRegion);
			if(r <= 2 && r > 1) mHardware[i] = new Sprite(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2, this.mHardware2TextureRegion);
			if(r <= 1) mHardware[i] = new Sprite(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2, this.mHardware3TextureRegion);
			
			
			mHardware[i].setVisible(false);	
			//final Body 

			//this.mScene.attachChild(mHardware[i]);
			
		}
		*/
		//this.addObstacle(CAMERA_WIDTH / 2, CAMERA_HEIGHT / 3);
		

		
		
		//this.addObstacle(CAMERA_WIDTH / 2, RACETRACK_WIDTH / 2);
		//this.addObstacle(CAMERA_WIDTH / 2, CAMERA_HEIGHT - RACETRACK_WIDTH / 2);
		//this.addObstacle(CAMERA_WIDTH / 2, CAMERA_HEIGHT - RACETRACK_WIDTH / 2);
		
		HjarlGameActivity.mScene.attachChild(box1);
		box1.setZIndex(40);
		HjarlGameActivity.mScene.attachChild(box2);
		box2.setZIndex(41);
		HjarlGameActivity.mScene.attachChild(box3);
		box3.setZIndex(42);
		HjarlGameActivity.mScene.attachChild(van);
		van.setZIndex(100);
		
		
		this.throwHardware(CAMERA_WIDTH + 5, CAMERA_HEIGHT / 3 * 2);
	}
	
	//private class HardwareControl {
		/*private final int mActiveRockets = 10;
		private final BulletPool BULLETPOOL = new BulletPool(mBox1TextureRegion);
		final SpriteGroup  BULLETSPRITEGROUP = new SpriteGroup (HjarlGameActivity.this.mTexture, mActiveRockets);
		//final SpriteGroup  EXPLOSIONSPRITEGROUP    = new SpriteGroup (Main.this.mTexture, mActiveRockets);
		
		HjarlGameActivity.this.BULLETPOOL.batchAllocatePoolItems(mActiveRockets);*/
		
	//}

	
	/*
	private void addObstacle(final float pX, final float pY) {
		final Sprite box = new Sprite(pX, pY, 32, 32, this.mBoxTextureRegion);

		final FixtureDef boxFixtureDef = PhysicsFactory.createFixtureDef(0.1f, 0.5f, 0.5f);
		final Body boxBody = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, box, BodyType.DynamicBody, boxFixtureDef);
		boxBody.setLinearDamping(0);
		boxBody.setAngularDamping(0);

		HjarlGameActivity.getmPhysicsWorld().registerPhysicsConnector(new PhysicsConnector(box, boxBody, true, true));
		
		HjarlGameActivity.mScene.attachChild(box);
		
		float X = (float) Math.random();
		float Y = (float) Math.random();
		
		Vector2 velocity = Vector2Pool.obtain(0.7f, 0.7f);
		
		if (mJarl.getX() < 100 && pValueX > 0) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		if (mJarl.getX() > 100 && mJarl.getX() < 400) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		if (mJarl.getX() > 400 && pValueX < 0) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		
		velocity = Vector2Pool.obtain(30, 10);
		
		boxBody.setLinearVelocity(velocity);
		Vector2Pool.recycle(velocity);
	}*/
	
	private void throwHardware(final float pX, final float pY) {
		//Sprite box = null; //new Sprite(pX, pY, 32, 32, this.mBoxTextureRegion);
		
		
		
		int active = 0;
		for (int i = 0; i < 10; i++) {
			if (hwactive[i] == false) {
				hwactive[i] = true;
				active = i;
				i = 11;
			}
		    if (hwactive[9] == true && hwactive[0] == true) active = 11;
		    	
		}
		
		if (active != 11) { // only makes hardware if there is any inactive hardware ready.
		final FixtureDef boxFixtureDef = PhysicsFactory.createFixtureDef(0.1f, 0.5f, 0.5f);
		final Sprite Hardware;
		final Body body;
		
		
		int r = (int) Math.round(Math.random() * 2);
		
		//mHardware[i] = new Sprite(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2, this.mHardware1TextureRegion);
		
		//mHardware[active] = new Sprite(pX, pY, this.mHardware3TextureRegion);

		if(r > 2) mHardware[active] = new Sprite(pX, pY, this.mHardware1TextureRegion);
		if(r == 2) mHardware[active] = new Sprite(pX, pY, this.mHardware2TextureRegion);
		if(r <= 1) mHardware[active] = new Sprite(pX, pY, this.mHardware3TextureRegion);
		if(r == 0) mHardware[active] = new Sprite(pX, pY, this.mHardware3TextureRegion);

		//Hardware = new Sprite(pX, pY, this.mHardware1TextureRegion);
		if(r == 0) {
			Hardware = new Sprite(pX, pY, this.mHardware1TextureRegion);
			body = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, Hardware, BodyType.DynamicBody, boxFixtureDef);
		} 
		else {
			if(r == 2) {
				Hardware = new Sprite(pX, pY, this.mHardware3TextureRegion);
				body = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, Hardware, BodyType.DynamicBody, boxFixtureDef);
			}
			else {
			
			Hardware = new Sprite(pX, pY, this.mHardware2TextureRegion);
			body = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, Hardware, BodyType.DynamicBody, boxFixtureDef);
		}}
		/*else
		if(r == 2) {
			Hardware = new Sprite(pX, pY, this.mHardware3TextureRegion);
			body = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, Hardware, BodyType.DynamicBody, boxFixtureDef);
		}*/
		mHardwareBody[active] = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, mHardware[active], BodyType.DynamicBody, boxFixtureDef);

		//body.setLinearDamping(0);
		//body.setAngularDamping(0);
		
		//HjarlGameActivity.getmPhysicsWorld().registerPhysicsConnector(new PhysicsConnector(mHardware[active], mHardwareBody[active], true, true));

		mScene.attachChild(mHardware[active]);
		
		this.mPhysicsWorldg.registerPhysicsConnector(new PhysicsConnector(mHardware[active], mHardwareBody[active], true, true));
		
		float X = (float) Math.random() * -10 -5;
		float Y = (float) Math.random() * -5 -10;
		
		Vector2 velocity = Vector2Pool.obtain(X, Y);
		/*
		if (mJarl.getX() < 100 && pValueX > 0) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		if (mJarl.getX() > 100 && mJarl.getX() < 400) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		if (mJarl.getX() > 400 && pValueX < 0) velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 0);
		*/
		//velocity = Vector2Pool.obtain(X, Y);
		
		mHardwareBody[active].setLinearVelocity(velocity);
		Vector2Pool.recycle(velocity);

		/*
		this.mPhysicsWorldg.registerPhysicsConnector(new PhysicsConnector(mHardware[active], mHardwareBody[active], true, true));
		
		mHardwareBody[active] = PhysicsFactory.createBoxBody(this.mPhysicsWorldg, mHardware[active], BodyType.DynamicBody, boxFixtureDef);
		mHardwareBody[active].setLinearDamping(0);
		mHardwareBody[active].setAngularDamping(0);
		this.mPhysicsWorldg.registerPhysicsConnector(new PhysicsConnector(mHardware[active], mHardwareBody[active], true, true));
		*/
		
		
		//Hardware.setZIndex(50);
		//HjarlGameActivity.mScene.sortChildren();
		
		} // only makes hardware if there is any inactive hardware ready.
		
		
	}

	/**
	 * @param mPhysicsWorld the mPhysicsWorld to set
	 
	public void setmPhysicsWorld(PhysicsWorld mPhysicsWorld) {
		HjarlGameActivity.mPhysicsWorld = mPhysicsWorldg;
	}*/

	/**
	 * @return the mPhysicsWorld
	 
	public static PhysicsWorld getmPhysicsWorld() {
		return mPhysicsWorldg;
	}*/

	private void destroyHardware(final Sprite hardware) {
		final PhysicsConnector mphysicsConnector = HjarlGameActivity.this.mPhysicsWorldg.getPhysicsConnectorManager().findPhysicsConnectorByShape(hardware);
		
		//mHardwareBody[active]
		
		if (mphysicsConnector.getBody() != null) {
		//this.mPhysicsWorldg.destroyBody(mphysicsConnector.getBody());
			hardware.setColor(0, 0, 1);
			//this.mPhysicsWorldg.unregisterPhysicsConnector(mphysicsConnector);
			//this.mPhysicsWorldg.destroyBody(mphysicsConnector.getBody());
			mScene.detachChild(hardware);
			System.gc();
		//this.mPhysicsWorldg.clearPhysicsConnectors();
		//this.mPhysicsWorldg.clearForces();
		//HjarlGameActivity.this.mScene.unregisterTouchArea(mHardware[i]);
		} else {
		this.mPhysicsWorldg.unregisterPhysicsConnector(mphysicsConnector);
		mScene.detachChild(hardware);
		System.gc();
		
		}
	}
	
	private void initBackground() {
        final int x = (CAMERA_WIDTH - this.BackgroundTextureRegion.getWidth()) / 2;
        final int y = (CAMERA_HEIGHT - this.BackgroundTextureRegion.getHeight()) / 2;
        
        final Sprite picture = new Sprite(x, y, this.BackgroundTextureRegion);
        mScene.attachChild(picture);
			//final TextureRegion Background = this.BackgroundTextureRegion.clone();
			//racetrackHorizontalStraightTextureRegion.setWidth(3 * this.mRacetrackStraightTextureRegion.getWidth());

			//final TextureRegion racetrackVerticalStraightTextureRegion = this.mRacetrackStraightTextureRegion;
	}


	private void initBorders() {
		
		final Shape bottomOuter = new Rectangle(0, CAMERA_HEIGHT - 2, CAMERA_WIDTH, 2);
		final Shape topOuter = new Rectangle(0, 0, CAMERA_WIDTH, 2);
		final Shape leftOuter = new Rectangle(0, 0, 2, CAMERA_HEIGHT);
		//final Shape rightOuter = new Rectangle(CAMERA_WIDTH - 2, 0, 2, CAMERA_HEIGHT);
		
		final Shape bottomOuterg = new Rectangle(0, CAMERA_HEIGHT - 2 * 20, CAMERA_WIDTH, 40);
		final Shape topOuterg = new Rectangle(0, 0, CAMERA_WIDTH, 2);
		final Shape leftOuterg = new Rectangle(0, 0, 2, CAMERA_HEIGHT);
		//final Shape rightOuterg = new Rectangle(CAMERA_WIDTH - 2, 0, 2, CAMERA_HEIGHT);

		/*
		final Shape bottomInner = new Rectangle(RACETRACK_WIDTH, CAMERA_HEIGHT - 2 - RACETRACK_WIDTH, CAMERA_WIDTH - 2 * RACETRACK_WIDTH, 2);
		final Shape topInner = new Rectangle(RACETRACK_WIDTH, RACETRACK_WIDTH, CAMERA_WIDTH - 2 * RACETRACK_WIDTH, 2);
		final Shape leftInner = new Rectangle(RACETRACK_WIDTH, RACETRACK_WIDTH, 2, CAMERA_HEIGHT - 2 * RACETRACK_WIDTH);
		final Shape rightInner = new Rectangle(CAMERA_WIDTH - 2 - RACETRACK_WIDTH, RACETRACK_WIDTH, 2, CAMERA_HEIGHT - 2 * RACETRACK_WIDTH);
*/


		final FixtureDef wallFixtureDef = PhysicsFactory.createFixtureDef(0, 0.5f, 0.5f);
		//PhysicsFactory.createBoxBody(HjarlGameActivity.getmPhysicsWorld(), bottomOuter, BodyType.StaticBody, wallFixtureDef);
		//PhysicsFactory.createBoxBody(HjarlGameActivity.getmPhysicsWorld(), topOuter, BodyType.StaticBody, wallFixtureDef);
		//PhysicsFactory.createBoxBody(HjarlGameActivity.getmPhysicsWorld(), leftOuter, BodyType.StaticBody, wallFixtureDef);
		//PhysicsFactory.createBoxBody(HjarlGameActivity.getmPhysicsWorld(), rightOuter, BodyType.StaticBody, wallFixtureDef);
		
		PhysicsFactory.createBoxBody(this.mPhysicsWorldg, bottomOuterg, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorldg, topOuterg, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorldg, leftOuterg, BodyType.StaticBody, wallFixtureDef);
		//PhysicsFactory.createBoxBody(this.mPhysicsWorldg, rightOuterg, BodyType.StaticBody, wallFixtureDef);
/*
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, bottomInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, topInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, leftInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, rightInner, BodyType.StaticBody, wallFixtureDef);
*/
		//HjarlGameActivity.mScene.attachChild(bottomOuter);
		//HjarlGameActivity.mScene.attachChild(topOuter);
		//HjarlGameActivity.mScene.attachChild(leftOuter);
		//HjarlGameActivity.mScene.attachChild(rightOuter);
		
		bottomOuterg.setVisible(false);
		HjarlGameActivity.mScene.attachChild(bottomOuterg);
		HjarlGameActivity.mScene.attachChild(topOuterg);
		HjarlGameActivity.mScene.attachChild(leftOuterg);
		//HjarlGameActivity.mScene.attachChild(rightOuterg);
/*
		this.mScene.attachChild(bottomInner);
		this.mScene.attachChild(topInner);
		this.mScene.attachChild(leftInner);
		this.mScene.attachChild(rightInner);*/
	}
	
	public boolean onKeyUp(final int pKeyCode, final KeyEvent pEvent) {
		if(pKeyCode == ControlKeyAction3[0] && JarlAction == 6 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			JarlAction = 0;
			//physicsHandler.setVelocity(-250, 0);
			return true;
		}
		if(pKeyCode == ControlKeyAction4[0] && JarlAction == 4 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			JarlAction = 0;
			//physicsHandler.setVelocity(-250, 0);
			return true;
		}
		return false;
	}
	
	@Override
	public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) {
		
		if(pKeyCode == KeyEvent.KEYCODE_MENU && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			if(this.mEngine.isRunning()) {
				HjarlGameActivity.mScene.setChildScene(this.mPauseScene, false, true, true);
				this.mEngine.stop();
			} else {
				HjarlGameActivity.mScene.clearChildScene();
				//this.initOnScreenControls();
				this.mEngine.start();
			}
			return true;
		}
		
		if (pKeyCode == KeyEvent.KEYCODE_BACK
				&& pEvent.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being pressed
			finish(); // Stop HardwareJarl
			return true;
		}
		
		//int key = HjarlGameActivity.controls.getKey(4, 1);
		//physicsHandler.setVelocity(-250, 0);
		/*
		if(physicsHandler.getVelocityX() != 0 && physicsHandler.getVelocityY() != 0) {
			return super.onKeyDown(pKeyCode, pEvent);
		}*/
		

		if(pKeyCode == ControlKeyAction1[4] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			HjarlGameActivity.this.throwHardware(CAMERA_WIDTH + 5, CAMERA_HEIGHT / 2);
			return true;
		}
		if(pKeyCode == ControlKeyAction4[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN && mJarl.getX() < 500) {
			JarlAction = 4;
			//physicsHandler.setVelocity(250, 0);
			return true;
		}
		if(pKeyCode == ControlKeyAction3[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN && mJarl.getX() > 50) {
			JarlAction = 6;
			//physicsHandler.setVelocity(-250, 0);
			return true;
		}
		
		else {
			return super.onKeyDown(pKeyCode, pEvent);
		}
		
	}

	// ===========================================================
	// Inner and Anonymous Classes
	// ===========================================================
}
