package dk.dionysus.hjarl;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

public class MenuActivity extends Activity {

	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        //setContentView(R.layout.main_new);
	        setContentView(R.layout.main);
	        
	        
	        Typeface font = Typeface.createFromAsset(getAssets(),"font/pf_tempesta_five.ttf");
	        
	        
		    TextView txtView = (TextView) findViewById(R.id.copyright);
		    txtView.setTypeface(font);
		    
		    txtView = (TextView) findViewById(R.id.website);
		    txtView.setTypeface(font);
		    
		    TextView btnHelp = (TextView) findViewById(R.id.btnHelp);
		    btnHelp.setTypeface(font);
		    
			btnHelp.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					Intent help = new Intent(MenuActivity.this, HelpActivity.class);
					startActivity(help);
				}
			});
	        
		    TextView btnExit = (TextView) findViewById(R.id.btnExit);
	        btnExit.setTypeface(font);
	        btnExit.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					showExitDialog();
				}
			});
	        
	        TextView btnAbout = (TextView) findViewById(R.id.btnAbout);
	        btnAbout.setTypeface(font);
	        btnAbout.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					AlertDialog.Builder alertbox = new AlertDialog.Builder(MenuActivity.this);
					alertbox.setTitle("ABOUT");
					alertbox.setIcon(R.drawable.icon);
					alertbox.setCancelable(false);
		            alertbox.setMessage("Nikola Trifunović is freelance web designer" +
		            					"and developer from Budva, Montenegro. He is " +
		            					"22 years old. Nikola is a student at the College " +
		            					"of Electrical Engineering and Computer Science " +
		            					"in Belgrade, Serbia. Nikola knows a lot of programming " +
		            					"languages, such as C, C++, Java, PHP, C#, Visual Basic" +
		            					"and Python.");
		 
		            alertbox.setPositiveButton("Close",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
								}
							});
					alertbox.setNegativeButton("Visit Website", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							String url = "http://www.trifunovic.me";
							Intent i = new Intent(Intent.ACTION_VIEW);
							i.setData(Uri.parse(url));
							startActivity(i);
						}
					});
		            alertbox.show();
				}
			});
	        
	        TextView btnStartGame = (TextView) findViewById(R.id.btnStartGame);
	        btnStartGame.setTypeface(font);
	        btnStartGame.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					Intent game = new Intent(MenuActivity.this, MovingBallExample.class);
					startActivity(game);
				}
			});
	        
	        TextView btnOptions = (TextView) findViewById(R.id.btnOptions);
	        btnOptions.setTypeface(font);
	        btnOptions.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					Intent game = new Intent(MenuActivity.this, OptionsActivity.class);
					startActivity(game);
				}
			});
	               
	        TextView btnHighscore = (TextView) findViewById(R.id.btnHighscore);
	        btnHighscore.setTypeface(font);
	        btnHighscore.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					AlertDialog.Builder alertbox = new AlertDialog.Builder(MenuActivity.this);
					alertbox.setTitle("HIGHSCORE");
					alertbox.setIcon(R.drawable.trophy);
					alertbox.setCancelable(false);
					
					Highscore score = new Highscore(MenuActivity.this);
					StringBuilder str = new StringBuilder();
					
					for(int i=0;i<10;i++){
						if(i!=9)
							str.append(i+1 +"  .  "+score.getName(i)+"  ("+score.getScore(i)+" points)\n");
						else
							str.append(i+1 +".  "+score.getName(i)+"  ("+score.getScore(i)+" points)\n");
					}
					
		            alertbox.setMessage(str.toString());
					
		            alertbox.setPositiveButton("Close",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
								}
							});
		            
		            alertbox.show();
		
				}
			});
	        
	    }
	    
	    
	    @Override
		public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) {

			if (pKeyCode == KeyEvent.KEYCODE_BACK
					&& pEvent.getAction() == KeyEvent.ACTION_DOWN) {
				showExitDialog();
				return true;
			}
			
			return super.onKeyDown(pKeyCode, pEvent);
		}
	    
	    public void showExitDialog() {
	    	AlertDialog.Builder builder = new AlertDialog.Builder(MenuActivity.this);
			builder.setMessage("Are you sure you want to exit?")
					.setCancelable(false)
					.setTitle("EXIT")
					.setPositiveButton("Yes",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
									MenuActivity.this.finish();
								}
							})
					.setNegativeButton("No", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							dialog.cancel();
						}
					});

			AlertDialog alert = builder.create();
			alert.setIcon(R.drawable.icon);
			alert.show();
	    
	    }
	    
}