package dk.dionysus.hjarl;

import javax.microedition.khronos.opengles.GL10;

import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.camera.hud.HUD;
import org.anddev.andengine.engine.handler.timer.ITimerCallback;
import org.anddev.andengine.engine.handler.timer.TimerHandler;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.background.ColorBackground;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.entity.text.ChangeableText;
import org.anddev.andengine.entity.util.FPSCounter;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.ui.activity.BaseGameActivity;
import org.anddev.andengine.extension.input.touch.controller.MultiTouch;
import org.anddev.andengine.extension.input.touch.controller.MultiTouchController;
import org.anddev.andengine.extension.input.touch.exception.MultiTouchException;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.KeyEvent;
import android.widget.Toast;

/**
 * (c) 2010 Nicolas Gramlich
 * (c) 2011 Zynga
 *
 * @author Nicolas Gramlich
 * @since 22:43:20 - 15.07.2010
 * 
 * @author Kasper Olesen
 * @since 18:29:20 - 19.12.2011
 */


public class OSControlSetup  extends BaseGameActivity {
	// ===========================================================
	// Constants
	// ===========================================================

	private static final int RACETRACK_WIDTH = 64;

	private static final int OBSTACLE_SIZE = 16;
	private static final int CAR_SIZE = 16;

	//private static final int CAMERA_WIDTH = RACETRACK_WIDTH * 5;
	//private static final int CAMERA_HEIGHT = RACETRACK_WIDTH * 3;
	
	//private static final int CAMERA_WIDTH = 480;
	//private static final int CAMERA_HEIGHT = 256;
	
	private static final int CAMERA_WIDTH = 640;
	private static final int CAMERA_HEIGHT = 384;

	// ===========================================================
	// Fields
	// ===========================================================

	private Camera mCamera;

	private BitmapTextureAtlas mOnScreenControlTexture;
	private TextureRegion mOnScreenControlBaseTextureRegion;
	private TextureRegion mOnScreenControlKnobTextureRegion;
	private TextureRegion sliderTextureRegion;

	private Scene mScene;
	
	private Sprite control[];
	float ControlX[];
	float ControlY[];
	float scale[];
	int ControlKeyAction1[];
	int ControlKeyAction2[];
	int ControlKeyAction3[];
	int ControlKeyAction4[];

	private Sprite sliderbar;
	private Sprite sliderknob;
	private int f = 0;
	private float C1X = 0;
	private float C1Y = 0;
	private float C1TX = 0;
	private float C1TY = 0;

	
	// HUD Text and HUD
    private BitmapTextureAtlas mFontTexture;
    private BitmapTextureAtlas mFontTexture2;
    private Font mFont;
    private Font mFontTiny;
    
    //private BitmapTextureAtlas mFontTexture2[];
    //private Font mFont2[];
    
    
    HUD hud = new HUD();

	// ===========================================================
	// Constructors
	// ===========================================================

	// ===========================================================
	// Getter & Setter
	// ===========================================================

	public static Options options;
	public static Controls controls;
	public static boolean save = true;
	
	// ===========================================================
	// Methods for/from SuperClass/Interfaces
	// ===========================================================

	
	public Engine onLoadEngine() {
		options = new Options(OSControlSetup.this);
		//controls = new Controls(RacerGameActivity.this);

		this.mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
		
    	//Attach HUD to the Camera
    	mCamera.setHUD(this.hud);
    	
    	final Engine engine = new Engine(new EngineOptions(true, ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT), this.mCamera));
    	
		try {
			if(MultiTouch.isSupported(this)) {
				engine.setTouchController(new MultiTouchController());
			} else {
				Toast.makeText(this, "Sorry your device does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)\n\nControls are placed at different vertical locations.", Toast.LENGTH_LONG).show();
			}
		} catch (final MultiTouchException e) {
			Toast.makeText(this, "Sorry your Android Version does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)\n\nControls are placed at different vertical locations.", Toast.LENGTH_LONG).show();
		}
    	    	
		return engine;
	}

	public void onLoadResources() {
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		
    	// HUD text
        this.mFontTexture = new BitmapTextureAtlas(128, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
        this.mFontTexture2 = new BitmapTextureAtlas(128, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
        this.mFont = new Font(this.mFontTexture, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 10, true, Color.WHITE);
        this.mFontTiny = new Font(this.mFontTexture2, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 12, true, Color.WHITE);
       /* for (int i = 0; i < 11; i++) {
            this.mFontTexture2[i] = new BitmapTextureAtlas(32, 32, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
            this.mFont2[i] = new Font(this.mFontTexture2[i], Typeface.create(Typeface.DEFAULT, Typeface.NORMAL), 10, true, Color.WHITE);
        }*/
        
		this.mOnScreenControlTexture = new BitmapTextureAtlas(512, 512, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mOnScreenControlBaseTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_base.png", 0, 0);
		this.mOnScreenControlKnobTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_knob.png", 128, 0);
		this.sliderTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "sliderbar2.png", 196, 0);
		
		this.mEngine.getTextureManager().loadTextures(this.mFontTexture, this.mFontTexture2, this.mOnScreenControlTexture);
		/*for (int i = 0; i < 11; i++) {
			this.mEngine.getTextureManager().loadTextures(this.mFontTexture2[i]);
		}*/
		
		this.mEngine.getFontManager().loadFont(this.mFont);
		this.mEngine.getFontManager().loadFont(this.mFontTiny);
	}

	
	public Scene onLoadScene() {
		this.mEngine.registerUpdateHandler(new FPSLogger());

		this.mScene = new Scene();
		this.mScene.setBackground(new ColorBackground(0, 0, 0));

        //final ChangeableText hudtxt[] = null;
        //hudtxt = new ChangeableText[11];

		this.initOnScreenControls();
		
        // Initiate FPS counter
        final FPSCounter fpsCounter = new FPSCounter();
        this.mEngine.registerUpdateHandler(fpsCounter);
        
        final ChangeableText fpsText = new ChangeableText(5, 5, this.mFont, "FPS:", "FPS: XXXXXX X: XXXXX Y: XXXXXXX TX: XXXXXX TY: XXXXXXX".length());
        // Attach FPS counter to HUD
        mScene.attachChild(fpsText);

        mScene.registerUpdateHandler(new TimerHandler(1 / 20.0f, true, new ITimerCallback() {
                public void onTimePassed(final TimerHandler pTimerHandler) {
                	//	hudtxt[f].setPosition(control[f].getX(),control[f].getY());

                	
                        fpsText.setText("FPS: " + Math.round(fpsCounter.getFPS()) + " X: " + control[f].getX() + " Y: " +
                        		ControlY[f] + " H: " + control[f].getHeight() + " GY: " + control[f].getY()
                        + " Scale: " + scale[f] + " " + control[f].getRed()
                        
                        );
                	
                	/*
                        fpsText.setText("FPS: " + Math.round(fpsCounter.getFPS()) + " X: " + control[f].getX() + " Y: " +
                        		ControlY[f] + " TX: " + Math.round(C1TX) + " TY: " + Math.round(C1TY)
                        + " Scale: " + scale[f] + " " + control[f].getRed()
                        
                        );*/
                }
        }));

		return this.mScene;
	}

	public void onLoadComplete() {

	}

	// ===========================================================
	// Methods
	// ===========================================================

	private void initOnScreenControls() {
		
		final Controls controls = new Controls(OSControlSetup.this);
		
		control = new Sprite[10];
		ControlX = new float[10];
		ControlY = new float[10];
		scale = new float[10];
		ControlKeyAction1 = new int[10];
		ControlKeyAction2 = new int[10];
		ControlKeyAction3 = new int[10];
		ControlKeyAction4 = new int[10];
		
       final ChangeableText hudtxt = new ChangeableText(11, 11, this.mFontTiny, "SCALE", "SCALE: XXXXX".length());
       mScene.attachChild(hudtxt);
       //hudtxt = new ChangeableText[11];

		for (int i = 0; i < 10; i++) {
			int s = 64;
			if (i < 4) s = 128;
			scale[i] = controls.getScale(i);
			
			ControlX[i] = controls.getX(i) * (CAMERA_WIDTH - s * scale[i]) / 100;;
			
			ControlY[i] = controls.getY(i) / 100 * (CAMERA_HEIGHT - s * scale[i]);
			
			ControlY[i] = ControlY[i] - s * (1 - scale[i]);
			
			ControlKeyAction1[i] = controls.getKey(i, 1);
			ControlKeyAction2[i] = controls.getKey(i, 2);
			ControlKeyAction3[i] = controls.getKey(i, 3);
			ControlKeyAction4[i] = controls.getKey(i, 4);
			
		}
		
		// Toast for debugging
		// Toast.makeText(OSControlSetup.this, "Scale:" + ControlSize, Toast.LENGTH_SHORT).show();
		
		this.sliderknob = new Sprite(CAMERA_WIDTH - mOnScreenControlKnobTextureRegion.getWidth() , 
				CAMERA_HEIGHT / 2, this.mOnScreenControlKnobTextureRegion) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				
            	float TouchY = pSceneTouchEvent.getY();
				if (TouchY  < CAMERA_HEIGHT / 4) TouchY = CAMERA_HEIGHT / 4;
				if (TouchY  > CAMERA_HEIGHT * 0.75f) TouchY = CAMERA_HEIGHT * 0.75f;
				this.setPosition(this.getX(), TouchY - this.getHeightScaled() / 2 );
				
				
				scale[f] = 2 - ((this.getY()+this.getHeightScaled() / 2) / CAMERA_HEIGHT) * 2;
				
				scale[f] = scale[f] * 20;
				scale[f] = Math.round(scale[f]);
				scale[f] = scale[f] / 20;
				
				hudtxt.setText("" + scale[f] + "");
				//hudtxt[0].setPosition(control[f].getX(),control[f].getY());
				
				
				hudtxt.setPosition(this.getX() - 20,this.getY());
				
				
				if (pSceneTouchEvent.getAction() == pSceneTouchEvent.ACTION_UP) {

					pSceneTouchEvent.set(control[f].getX() + control[f].getWidthScaled() / 2, control[f].getY() + control[f].getHeight() * (2 - scale[f])/ 2);
					
					control[f].onAreaTouched(pSceneTouchEvent, control[f].getX() + control[f].getWidthScaled() / 2, control[f].getY() + control[f].getHeight() * (2 - scale[f])/ 2);
					
				}
			
				control[f].setScale(scale[f]);
				
				return true;
			}
		};
		sliderknob.setWidth(CAMERA_WIDTH / 10);
		sliderknob.setHeight(CAMERA_WIDTH / 20);
		
		
		//this.sliderbar = new Sprite(CAMERA_WIDTH - CAMERA_WIDTH / 20, 0, this.sliderTextureRegion);
		this.sliderbar = new Sprite(CAMERA_WIDTH - CAMERA_WIDTH / 12, CAMERA_HEIGHT / 4, this.sliderTextureRegion);
		sliderbar.setWidth(CAMERA_WIDTH / 20);
		sliderbar.setHeight(CAMERA_HEIGHT / 2);
		this.sliderbar.setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		this.sliderbar.setAlpha(0.2f);

		mScene.attachChild(sliderbar);
		mScene.attachChild(sliderknob);
		mScene.registerTouchArea(sliderknob);


		
		for (int i = 0; i < 4; i++) {
			this.control[i] = new Sprite(ControlX[i], ControlY[i], this.mOnScreenControlBaseTextureRegion) {
            @Override
            public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
            	float TouchX = pSceneTouchEvent.getX();
            	float TouchY = pSceneTouchEvent.getY();
            	if ((TouchX + this.getWidth() * this.getScaleX() / 2) > CAMERA_WIDTH) TouchX = CAMERA_WIDTH - this.getWidth() * this.getScaleX() / 2;
            	if ((TouchY + this.getHeight() * this.getScaleY() / 2) > CAMERA_HEIGHT) TouchY = CAMERA_HEIGHT - this.getHeight() * this.getScaleY() / 2;
            	
            	if ((TouchX - this.getWidth() * this.getScaleX() / 2) < 0) TouchX = this.getWidth() * this.getScaleX() / 2;
            	if ((TouchY - this.getHeight() * this.getScaleY() / 2) < 0) TouchY = this.getHeight() * this.getScaleY() / 2;           	
            			
				this.setPosition(TouchX - this.getWidthScaled() / 2, TouchY - this.getHeight() * (2 - this.getScaleY())/ 2);

				C1TX = pTouchAreaLocalX;
				C1TY = pTouchAreaLocalY;
        		C1X = Math.round(this.getX() * 100 / CAMERA_WIDTH);
        		C1Y = Math.round(this.getY() * 100 / CAMERA_HEIGHT);
            	
        		if (this.getRed() == 1)
        		for (int i = 0; i < 10; i++) {
					control[i].setColor(1, 1, 1);
				}
        		this.setColor(0, 1, 0);
        		
            	if (pSceneTouchEvent.getAction() == pSceneTouchEvent.ACTION_UP) {
            		
            		this.setPosition(C1X * CAMERA_WIDTH / 100, C1Y * CAMERA_HEIGHT / 100);
            		
    				for (int i = 0; i < 10; i++) {
    					control[i].setColor(1,1,1);
    					ControlX[i] = control[i].getX();
    					ControlY[i] = control[i].getY();
    				}
    				this.setColor(0, 1, 0);
    				for (int i = 0; i < 10; i++) {
    					if (control[i].getRed() == 0) f = i;
    				}
            	}
				return true;
            }
		};
		
		// Later it will be checked how many controlpads and buttons to attach.
		// mScene.attachChild(control[i]);
		// mScene.registerTouchArea(control[i]);
	
		
		control[i].setScale(scale[i]);
		this.control[i].setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		this.control[i].setAlpha(0.5f);
		this.control[i].setScaleCenter(0, 128);
		}

		
		for (int i = 4; i < 10; i++) {
			this.control[i] = new Sprite(ControlX[i], ControlY[i], this.mOnScreenControlKnobTextureRegion) {
	            @Override
	            public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
	            	float TouchX = pSceneTouchEvent.getX();
	            	float TouchY = pSceneTouchEvent.getY();
	            	C1X = this.getX();
	            	C1Y = this.getY();
	            	
	            	if ((TouchX + this.getWidth() * this.getScaleY() / 2) > CAMERA_WIDTH) TouchX = CAMERA_WIDTH - this.getWidth() * this.getScaleY() / 2;
	            	if ((TouchY + this.getHeight() * this.getScaleY() / 2) > CAMERA_HEIGHT) TouchY = CAMERA_HEIGHT - this.getHeight() * this.getScaleY() / 2;
	            	
	            	if ((TouchX - this.getWidth() * this.getScaleY() / 2) < 0) TouchX = this.getWidth() * this.getScaleY() / 2;
	            	if ((TouchY - this.getHeight() * this.getScaleY() / 2) < 0) TouchY = this.getHeight() * this.getScaleY() / 2;           	
	            			
					this.setPosition(TouchX - this.getWidthScaled() / 2, TouchY - this.getHeight() * (2 - this.getScaleY())/ 2);
					
	            	controls.setX(0, this.getX());
					controls.setY(0, this.getY());
					C1TX = pTouchAreaLocalX;
					C1TY = pTouchAreaLocalY;
	        		C1X = Math.round(this.getX() * 100 / CAMERA_WIDTH);
	        		C1Y = Math.round(this.getY() * 100 / CAMERA_HEIGHT);
	            	
	        		if (this.getRed() != 0) { //make sure the touched control is green
	    				for (int i = 0; i < 10; i++) {
	    					control[i].setColor(1, 1, 1);
	    				}
	    				this.setColor(0, 1, 0);
	        		}
	        		
	        		
	            	if (pSceneTouchEvent.getAction() == pSceneTouchEvent.ACTION_UP) {

	            		this.setPosition(C1X * CAMERA_WIDTH / 100, C1Y * CAMERA_HEIGHT / 100);
	                	
	    				for (int i = 0; i < 10; i++) {
	    					control[i].setColor(1,1,1);
	    					ControlX[i] = control[i].getX();
	    					ControlY[i] = control[i].getY();// + control[i].getHeight() * (1-control[i].getScaleY());
	    					//ControlY[i] = control[i].getY() + control[i].getHeight() * (2 - control[i].getScaleY())/ 2;
	    				}
	    				this.setColor(0, 1, 0);
	    				
	    				for (int i = 0; i < 10; i++) {
	    					if (control[i].getRed() == 0) f = i;
	    				}
	            	}

					return true;
	            }
			};

			
			control[i].setScale(scale[i]);
			this.control[i].setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
			this.control[i].setAlpha(0.5f);
			this.control[i].setScaleCenter(0, 64);
			}
		

		mScene.setTouchAreaBindingEnabled(true);
		// Toast for debugging
		Toast.makeText(OSControlSetup.this, "Scale:" + scale, Toast.LENGTH_SHORT).show();
	
    	//controls.setX(f, control[f].getX());
		//controls.setY(f, control[f].getY());

		int controlpads = options.getControlPads(); // Check how many controlpads to show
		int buttons = options.getButtons(); // Check how many buttons to show
		
		for (int i = 0; i < controlpads; i++) {
			mScene.attachChild(control[i]);
			mScene.registerTouchArea(control[i]);
		}
		for (int i = 4; i < (buttons+4); i++) {
			mScene.attachChild(control[i]);
			mScene.registerTouchArea(control[i]);
		}
		
		
	}
	
    @Override
	public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) { 
    	// Maybe the user decides to use Android buttons instead? Lets try to stop the user from quitting with the back button, by accident.

		if (pKeyCode == KeyEvent.KEYCODE_BACK
				&& pEvent.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being pressed
			showExitDialog(); // Run the showExitDialog.
			return true;
		}
		
		if(pKeyCode == KeyEvent.KEYCODE_MENU && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			if (f < 4) {
				BindkeysDialog(1);
			}
			else BindkeysDialog(0);
			
			// TODO Auto-generated method stub
		}
		
		Toast.makeText(OSControlSetup.this, "Keycode:" + pKeyCode, Toast.LENGTH_SHORT).show();
		return super.onKeyDown(pKeyCode, pEvent);
	}
    
    public void BindkeysDialog(final int i) { // Here a Key binding dialog is prepared. Its a kind of sub menu.
    	AlertDialog.Builder keygetter = new AlertDialog.Builder(OSControlSetup.this); // Making an AlerDialog, its an Android feature

    	if (i == 0)
    	keygetter.setMessage("Press button " + f).setCancelable(false).setTitle("Button " + f)
				.setOnKeyListener(new DialogInterface.OnKeyListener() {		
							@Override
							public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
								// TODO Auto-generated method stub
								if (event.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being released
									ControlKeyAction1[f] = keyCode;
									Toast.makeText(OSControlSetup.this, "Keycode0:" + keyCode, Toast.LENGTH_SHORT).show();
									dialog.cancel();
									//controls.setKey(f, keyCode, 1);
									return true;
								}
								return false;
							}
						});
    	if (i == 1)
    	keygetter.setMessage("Press UP key").setCancelable(false).setTitle("Control " + f + " UP key")
				.setOnKeyListener(new DialogInterface.OnKeyListener() {		
							@Override
							public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
								// TODO Auto-generated method stub
								if (event.getAction() == KeyEvent.ACTION_DOWN) { // Check if the button is being released
									ControlKeyAction1[f] = keyCode;
									//controls.setKey(f, keyCode, 1);
									Toast.makeText(OSControlSetup.this, "Keycode1:" + keyCode, Toast.LENGTH_SHORT).show();
									dialog.cancel();
									BindkeysDialog(2);
									return true;
								}	
								return false;
							}
						});
    	if (i == 2)
    	keygetter.setMessage("Press DOWN key").setCancelable(false).setTitle("Control " + f + " DOWN key")
				.setOnKeyListener(new DialogInterface.OnKeyListener() {		
							@Override
							public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
								// TODO Auto-generated method stub
								if (event.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being released
									ControlKeyAction2[f] = keyCode;
									//controls.setKey(f, keyCode, 2);
									Toast.makeText(OSControlSetup.this, "Keycode2:" + keyCode, Toast.LENGTH_SHORT).show();
									dialog.cancel();
									BindkeysDialog(3);
									return true;
								}
								
								return false;
							}
							
						});
    	
    	if (i == 3)
    	keygetter.setMessage("Press LEFT key").setCancelable(false).setTitle("Control " + f + " LEFT key")
				.setOnKeyListener(new DialogInterface.OnKeyListener() {		
							@Override
							public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
								// TODO Auto-generated method stub
								if (event.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being released
									ControlKeyAction3[f] = keyCode;
									//controls.setKey(f, keyCode, 3);
									Toast.makeText(OSControlSetup.this, "Keycode3:" + keyCode, Toast.LENGTH_SHORT).show();
									dialog.cancel();
									BindkeysDialog(4);
									return true;
								}
								
								return false;
							}
						});
    	if (i == 4)
    	keygetter.setMessage("Press RIGHT key").setCancelable(false).setTitle("Control " + f + " RIGHT key")
				.setOnKeyListener(new DialogInterface.OnKeyListener() {		
							@Override
							public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
								// TODO Auto-generated method stub
								if (event.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being released
									ControlKeyAction4[f] = keyCode;
									//controls.setKey(f, keyCode, 4);
									Toast.makeText(OSControlSetup.this, "Keycode4:" + keyCode, Toast.LENGTH_SHORT).show();
									dialog.cancel();
									return true;
								}
								
								return false;
							}
							
		
						});

		AlertDialog alert = keygetter.create(); // This takes the AlertDialog and prepares it
		alert.setIcon(R.drawable.icon); // Puts the application icon in the drawable folder into the dialog
		alert.show(); // shows the alert dialog
    }
    
    
    public void showExitDialog() { // Here a showExitDialog is prepared. Its a kind of submenu, but since it is very simple its all done without XML
    	AlertDialog.Builder builder = new AlertDialog.Builder(OSControlSetup.this); // Making an AlerDialog, its an Android feature
		builder.setMessage("Are you sure you want to exit?")
				.setCancelable(false)
				.setTitle("EXIT")
				.setPositiveButton("Yes",
						new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int id) {
								//final Highscore highscore = new Highscore(getApplicationContext());
								final Controls control = new Controls(getApplicationContext());
								
								if(save)
								{
								runOnUiThread(new Runnable() {
									
									public void run() {
										AlertDialog.Builder alert = new AlertDialog.Builder(OSControlSetup.this);
										alert.setTitle("Notice");
										alert.setIcon(R.drawable.trophy);
										alert.setMessage("Do you want to save these settings?");

										/*
										final LinearLayout layout = new LinearLayout(OSControlSetup.this);
										final EditText input = new EditText(OSControlSetup.this);
										layout.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT));
										input.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT));
										layout.setPadding(20, 0, 20, 0);
										layout.addView(input);
										
										alert.setView(layout);
										*/
										alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
										public void onClick(DialogInterface dialog, int whichButton) {
										  //String value = input.getText().toString();
										  
											//highscore.addScore(value,score.getScore());
											for (int i = 0; i < 10; i++) {
												float x = Math.round(ControlX[i]);
												
												float y = Math.round(ControlY[i]);

												float s = 64;
												if (i < 4) s = 128;
												
												float Scale = scale[i];
												
												float maxX = CAMERA_WIDTH - s * scale[i];
												float maxY = CAMERA_HEIGHT - s * scale[i];
												
												x = Math.round(x * 100 / maxX);
												
												y = y + s * (1 - scale[i]);
												
												y = Math.round(y * 100 / maxY);

												// Toast for debugging
												if (i == 0)
												Toast.makeText(OSControlSetup.this, i + " X:" + x + "% Y:" + y + "% S:" + Scale, Toast.LENGTH_SHORT).show();
												control.setKey(i, ControlKeyAction1[i], 1);
												control.setKey(i, ControlKeyAction2[i], 2);
												control.setKey(i, ControlKeyAction3[i], 3);
												control.setKey(i, ControlKeyAction4[i], 4);
												if (i == 4)
												Toast.makeText(OSControlSetup.this, i + " Button 4:" + ControlKeyAction1[i], Toast.LENGTH_SHORT).show();
												control.changeControl(i, x, y, Scale);

											}
											

											finish();
										}
										});

										alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
										  public void onClick(DialogInterface dialog, int whichButton) {
											  finish();
										  }
										});

										alert.show();
									}
								});
								}else{
									finish();
								}
								//MovingBallExample.this.finish(); // if yes is clicked, close this class. If this class had been opened by another class, we would return to that class.
							}
						})
				.setNegativeButton("No", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						dialog.cancel(); // Of the NO choice is clicked, we cancel the AlertDialog and go back to Menuactivity2
					}
				});

		AlertDialog alert = builder.create(); // This takes the AlertDialog and prepares it
		alert.setIcon(R.drawable.icon); // Puts the application icon in the drawable folder into the dialog
		alert.show(); // shows the alert dialog
    
    }
	// ===========================================================
	// Inner and Anonymous Classes
	// ===========================================================
	
	/*
	public void Maketext(long X, long Y, String txt){
		runOnUiThread(new Runnable() {	
		    private BitmapTextureAtlas mFontTexture3;
		    private Font mFont3;
	        ChangeableText uitxt = null;
	        //hudtxt = new ChangeableText[11];
			
			@Override
			public void run() {
				//GameActivity.scoreView.setText("SCORE: "+score.getScore());				
		        for (int i = 0; i < 11; i++) {
		        	uitxt = new ChangeableText(0, 0, this.mFont3, "0", "00".length());
		            mScene.attachChild(uitxt);
		            
		        }
			}
		});
	}
	*/
}

