package dk.dionysus.hjarl;

import android.app.Activity;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

public class Options {
	
	SharedPreferences options;
	
	public Options(Activity activity){
		options = PreferenceManager.getDefaultSharedPreferences(activity);
	}
	

	
	public boolean getSprite(){
		return options.getBoolean("chkSprite",true);
	}	
	
	public boolean getSoundEffects(){
		return options.getBoolean("chkSound",false);
	}
	
	public int getSFXVolume(){
		return options.getInt("chkSoundVol",100);
	}
	
	public boolean getMusic(){
		return options.getBoolean("chkMusic",false);
	}
	
	public int getMusicVolume(){
		return options.getInt("chkMusicVol",80);
	}
	
	public int getControlPads(){
		return options.getInt("chkControlPads",4);
	}
	public int getButtons(){
		return options.getInt("chkButtons",6);
	}
	
	public boolean getVibration(){
		return options.getBoolean("chkVibration",false);
	}
	
	public boolean getAutoFire(){
		return options.getBoolean("chkAutoFire",false);
	}
	
	public String getUsername(){
		return options.getString("edUsername",null);
	}
	
	public String getControlls(){
		return options.getString("lstControls","-1");
	}
	
	public String getDifficulty(){
		return options.getString("lstDifficulty","-1");
	}
	
	public String getResolution(){
		return options.getString("lstResolution","-1");
	}
	
	public boolean save(boolean sfx, boolean music, boolean sprite, boolean vibrate, int controlpads, int buttons, int sfxvol, int musvol) {
		// Save the changes made to options
		SharedPreferences.Editor editor = options.edit();
			editor.putBoolean("chkSprite", sprite);
			editor.putBoolean("chkSound", sfx);
			editor.putBoolean("chkMusic", music);
			editor.putBoolean("chkVibration", vibrate);
			editor.putInt("chkSoundVol", sfxvol);
			editor.putInt("chkMusicVol", musvol);
			editor.putInt("chkControlPads", controlpads);
			editor.putInt("chkButtons", buttons);
		editor.commit();
		return true;

	}

}
