package dk.dionysus.hjarl;

import java.util.ArrayList;
import java.util.List;

import javax.microedition.khronos.opengles.GL10;

import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.camera.hud.HUD;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.FillResolutionPolicy;
import org.anddev.andengine.entity.primitive.Rectangle;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.Scene.IOnSceneTouchListener;
import org.anddev.andengine.entity.scene.background.ColorBackground;
import org.anddev.andengine.entity.sprite.AnimatedSprite;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.entity.text.ChangeableText;
import org.anddev.andengine.entity.text.Text;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.input.touch.detector.ClickDetector;
import org.anddev.andengine.input.touch.detector.ClickDetector.IClickDetectorListener;
import org.anddev.andengine.input.touch.detector.ScrollDetector;
import org.anddev.andengine.input.touch.detector.ScrollDetector.IScrollDetectorListener;
import org.anddev.andengine.input.touch.detector.SurfaceScrollDetector;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.opengl.font.FontFactory;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.ui.activity.BaseGameActivity;
import org.anddev.andengine.util.HorizontalAlign;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.view.KeyEvent;
import android.widget.Toast;


/**
 * 
 * @author Knoll Florian
 * @email myfknoll@gmail.com
 * 
 * @since 28.02.2012
 * @author Kasper Olesen
 * @website http://dionysus.dk/devstuff
 *
 */
public class OptionsActivity2 extends BaseGameActivity implements IScrollDetectorListener, IOnSceneTouchListener, IClickDetectorListener {
       
        // ===========================================================
        // Constants
        // ===========================================================
        protected static int CAMERA_WIDTH = 480;
        protected static int CAMERA_HEIGHT = 320;
 
        protected static int FONT_SIZE = 20;
        protected static int PADDING = 50;
        
        protected static int MENUITEMS = 7;
        
 
        // ===========================================================
        // Fields
        // ===========================================================
        private Scene mScene;
        private Camera mCamera;
 
        private Font mFont; 
        private BitmapTextureAtlas mFontTexture;     
        
        private BitmapTextureAtlas mMenuTextureAtlas;        
        private TextureRegion mMenuLeftTextureRegion;
        private TextureRegion mMenuRightTextureRegion;
        
    	// Buttons
    	private TiledTextureRegion ToggleButtonTextureRegion;
    	private TextureRegion SoundButtonTextureRegion;
    	private TextureRegion PauseButtonTextureRegion;
        
    	//Background
    	private BitmapTextureAtlas BackgroundTexture;
    	private TextureRegion BackgroundTextureRegion;
    	private Sprite background;
    	
    	private BitmapTextureAtlas TitleTexture;
    	private TextureRegion TitleTextureRegion;
    	private Sprite title;
    	
    	
    	HUD hud = new HUD();
        
        private Sprite menuleft;
        private Sprite menuright;
 
        // Scrolling
        private SurfaceScrollDetector mScrollDetector;
        private ClickDetector mClickDetector;
 
        private float mMinX = 0;
        private float mMaxX = 0;
        private float mMinY = 0;
        private float mMaxY = 0;       
        private float mCurrentX = 0;
        private float mCurrentY = 0;
        private int iItemClicked = -1;
        
        private Rectangle scrollBar;
        
        private int MenuValue[];
        private int MenuItemValue[];
        private TiledTextureRegion TButton;
        private AnimatedSprite ToggleButton[];
        private List<String> MenuItem = new ArrayList<String>();
        private List<String> MenuType = new ArrayList<String>();

        
        private List<TextureRegion> columns = new ArrayList<TextureRegion>();

        // ===========================================================
        // Constructors
        // ===========================================================
 
        // ===========================================================
        // Getter & Setter
        // ===========================================================
 
        // ===========================================================
        // Methods for/from SuperClass/Interfaces
        // ===========================================================
        
    	public static Options options;
    	public static Controls controls;
    	public static boolean save = true;
 
        @Override
        public void onLoadResources() {
        	options = new Options(OptionsActivity2.this);
                // Paths
                FontFactory.setAssetBasePath("font/");
                BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
 
                // Font
                this.mFontTexture = new BitmapTextureAtlas(256, 256);
                this.mFont = FontFactory.createFromAsset(this.mFontTexture, this, "DIRTYDOZ.TTF", FONT_SIZE, true, Color.RED);
                this.mEngine.getTextureManager().loadTextures(this.mFontTexture);
                this.mEngine.getFontManager().loadFonts(this.mFont);
                
        		this.BackgroundTexture = new BitmapTextureAtlas(1024, 1024, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
        		this.BackgroundTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.BackgroundTexture, this, "baggrund.jpg", 0, 0);
        		this.TitleTexture = new BitmapTextureAtlas(512, 512, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
        		this.TitleTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.TitleTexture, this, "menu/title.png", 0, 0);
                

        		
        		/* The data for the menu
        		 * MenuValue is to determine the highest possible value of the slider, the onoff type is either 0 or 1 (false or true).
        		 * MenuItem is the description text for the menu
        		 * MenuType is to set different types of menu items.
        		*/
        		
        		
        		MenuValue = new int[10];
        		ToggleButton = new AnimatedSprite[10];
        		MenuItem.add("Options");		MenuType.add("Title");
        		MenuItem.add("Sprite");			MenuType.add("OnOff");MenuValue[MenuItem.size()-1] = 0;
        		MenuItem.add("Music");			MenuType.add("OnOff");MenuValue[MenuItem.size()-1] = 0; 
        		MenuItem.add("Music Volume");	MenuType.add("Slider");MenuValue[MenuItem.size()-1] = 100; 
        		MenuItem.add("Sound");			MenuType.add("OnOff");MenuValue[MenuItem.size()-1] = 0;
        		MenuItem.add("Sound Volume");	MenuType.add("Slider");MenuValue[MenuItem.size()-1] = 100;
        		MenuItem.add("Controlpads");	MenuType.add("Slider");MenuValue[MenuItem.size()-1] = 4;
        		MenuItem.add("buttons");		MenuType.add("Slider");MenuValue[MenuItem.size()-1] = 6;
        		MenuItem.add("Vibration");		MenuType.add("OnOff");MenuValue[MenuItem.size()-1] = 0;
        		MenuItem.add("");				MenuType.add("Empty");
        		
        		// Check if any of these settings are not the default setting and change it if so.
        		if (options.getSprite()) MenuValue[1] = 1;
        		if (options.getMusic()) MenuValue[2] = 1;

        		if (options.getSoundEffects()) MenuValue[4] = 1;
        		if (options.getVibration()) MenuValue[8] = 1;
        		


           	 	
           	 
        		// Slider types will be checked in the slider function
        		
        		
                //Images for the menu
        		/*
                for (int i = 0; i < MENUITEMS; i++) {				
                	BitmapTextureAtlas mMenuBitmapTextureAtlas = new BitmapTextureAtlas(256,256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
            		TextureRegion mMenuTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(mMenuBitmapTextureAtlas, this, "menu/menu"+i+".png", 0, 0);
            		
                	this.mEngine.getTextureManager().loadTexture(mMenuBitmapTextureAtlas);
                	columns.add(mMenuTextureRegion);
                	}
                	*/
        		
                //Textures for menu arrows
                this.mMenuTextureAtlas = new BitmapTextureAtlas(128,128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
                this.mMenuLeftTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(mMenuTextureAtlas, this, "menu/menu_left.png", 0, 0);
                this.mMenuRightTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(mMenuTextureAtlas, this, "menu/menu_right.png",64, 0);
                this.mEngine.getTextureManager().loadTextures(mMenuTextureAtlas, BackgroundTexture, TitleTexture);
          
        }
 
        @Override
        public Engine onLoadEngine() {
                this.mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
 
                final EngineOptions engineOptions = new EngineOptions(true, ScreenOrientation.LANDSCAPE, new FillResolutionPolicy(), this.mCamera);
                engineOptions.getTouchOptions().setRunOnUpdateThread(true);
 
                final Engine engine = new Engine(engineOptions);
                return engine;
        }
 
        @Override
        public Scene onLoadScene() {
                this.mEngine.registerUpdateHandler(new FPSLogger());
 
                this.mScene = new Scene();
                this.mScene.setBackground(new ColorBackground(255, 255, 255));
               
                int x = (CAMERA_WIDTH - this.BackgroundTextureRegion.getWidth()) / 2;
                int y = (CAMERA_HEIGHT - this.BackgroundTextureRegion.getHeight()) / 2;
                
                background = new Sprite(x, y, this.BackgroundTextureRegion);
                background.setScale(1.25f);
                //mScene.attachChild(background);
                
                
                x = (CAMERA_WIDTH - this.TitleTextureRegion.getWidth()) / 2;
                y = (this.TitleTextureRegion.getHeight() / 2);
                
                title = new Sprite(x, y, this.TitleTextureRegion);
                title.setScale(0.8f);
                mScene.attachChild(title);
                
                
                this.mScrollDetector = new SurfaceScrollDetector(this);
                this.mClickDetector = new ClickDetector(this);
 
                this.mScene.setOnSceneTouchListener(this);
                this.mScene.setTouchAreaBindingEnabled(true);
                this.mScene.setOnSceneTouchListenerBindingEnabled(true);
 
                CreateMenuBoxes();
 
                return this.mScene;
 
        }
 
        @Override
        public boolean onSceneTouchEvent(final Scene pScene, final TouchEvent pSceneTouchEvent) {
                this.mClickDetector.onTouchEvent(pSceneTouchEvent);
                this.mScrollDetector.onTouchEvent(pSceneTouchEvent);
                return true;
        }
 
        @Override
        public void onScroll(final ScrollDetector pScollDetector, final TouchEvent pTouchEvent, final float pDistanceX, final float pDistanceY) {

        		//Disable the menu arrows left and right (15px padding)
	        /*	
        	if(mCamera.getMinX()<=15)
	             	menuleft.setVisible(false);
	             else
	             	menuleft.setVisible(true);
	        	 
	        	 if(mCamera.getMinX()>mMaxX-15)
		             menuright.setVisible(false);
		         else
		        	 menuright.setVisible(true);
	          */   	
                //Return if ends are reached
                if ( ((mCurrentY - pDistanceY) < mMinY)  ){                	
                    return;
                }else if((mCurrentY - pDistanceY) > mMaxY){
                	
                	return;
                }
                
                //Center camera to the current point
                this.mCamera.offsetCenter(0,-pDistanceY );
                //mCurrentX -= pDistanceX;
                mCurrentY -= pDistanceY;
                
               
                //Set the scrollbar with the camera
                float tempX =mCamera.getCenterX()-CAMERA_WIDTH/2;
                float tempY =mCamera.getCenterY()-CAMERA_HEIGHT/2;
                // add the % part to the position
                tempX+= (tempX/(mMaxX+CAMERA_WIDTH))*CAMERA_WIDTH;
                
                tempY+= (tempY/(mMaxY+CAMERA_HEIGHT))*CAMERA_HEIGHT;
                //set the position
                scrollBar.setPosition(scrollBar.getX(), tempY);
                
                //set the arrows for left and right
                /*
                menuright.setPosition(mCamera.getCenterX()+CAMERA_WIDTH/2-menuright.getWidth(),menuright.getY());
                menuleft.setPosition(mCamera.getCenterX()-CAMERA_WIDTH/2,menuleft.getY());
                */
                
                background.setPosition(mCamera.getCenterX()-background.getWidth() / 2,background.getY());
                title.setPosition(mCamera.getCenterX()-title.getWidth() / 2,title.getY());
                
                //Because Camera can have negativ X values, so set to 0
            	if(this.mCamera.getMinX()<0){
            		this.mCamera.offsetCenter(0,0);
            		mCurrentX=0;
            	}
            	
 
        }
 
        @Override
        public void onClick(ClickDetector pClickDetector, TouchEvent pTouchEvent) {
                loadLevel(iItemClicked);
        };
 
        // ===========================================================
        // Methods
        // ===========================================================
        
        private void CreateMenuBoxes() {
        	
        	MenuItemValue = new int[MenuItem.size()];
        	
       	 	MenuItemValue[3] = options.getMusicVolume();
       	 	MenuItemValue[5] = options.getSFXVolume();
       	 	MenuItemValue[6] = options.getControlPads();
       	 	MenuItemValue[7] = options.getButtons();
        	
             int spriteX = PADDING;
        	 int spriteY = PADDING;

        	 //current item counter
             int iItem = 1;

        	 for (int x = 0; x < MenuItem.size(); x++) {
        		 Text menuitemtext = null;
        		 //int spriteY = PADDING;
        		 
        		 //On Touch, save the clicked item in case it's a click and not a scroll.
                final int itemToLoad = iItem;
        		 
        		 //Sprite sprite = new Sprite(PADDING,spriteY + CAMERA_HEIGHT / 4 - 15,columns.get(x)){
                if (MenuType.get(x) == "Title") {
                    menuitemtext = new Text(spriteX,spriteY + CAMERA_HEIGHT / 4 - 15, this.mFont, MenuItem.get(x)){	 
           			 public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
                            iItemClicked = itemToLoad;
                            return false;
           			 }
           		 };
                }
                
                if (MenuType.get(x) == "OnOff") {

                	menuitemtext = new Text(spriteX,spriteY + CAMERA_HEIGHT / 4 - 15, this.mFont, MenuItem.get(x)){	 
           			 public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
           				 	
                            iItemClicked = itemToLoad;
                            return false;
           			 }
           		 };
         		this.ToggleButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.BackgroundTexture, this, "buttons/ToggleBox.png", 0, 900, 2, 1);
         		
           		ToggleButton[x] = new AnimatedSprite(CAMERA_WIDTH * 5/8, spriteY + CAMERA_HEIGHT / 4 - 15, this.ToggleButtonTextureRegion) {
           			
						@Override
        				public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
        					if(pSceneTouchEvent.isActionDown()) {
        						if(OptionsActivity2.this.MenuValue[itemToLoad - 1] == 0) {
        							this.setCurrentTileIndex(1);
        							//this.ToggleButtonTextureRegion.createTiledFromAsset(this.BackgroundTexture, this, this.mToggleBox ? "gfx/face_box_tiled.png" : "gfx/face_circle_tiled.png", 0, 0, 2, 1);
        							//this.setColor(1, 1, 1);
        							//this.setScale(1);
        							MenuValue[itemToLoad - 1] = 1;
        						} else {
        							MenuValue[itemToLoad - 1] = 0;
        							this.setCurrentTileIndex(0);
        							//this.setColor(0.7f, 0.7f, 0.7f);
        							//this.setScale(0.9f);
        						}
        					}

        					return true;
        				}
						
        			};
        			if(MenuValue[x] == 1) ToggleButton[x].setCurrentTileIndex(1); // Make sure the toggle box is checked if true
        			
        			mScene.attachChild(ToggleButton[x]);
        			mScene.registerTouchArea(ToggleButton[x]);
        			
                }
                if (MenuType.get(x) == "Slider") {
                    menuitemtext = new Text(spriteX,spriteY + CAMERA_HEIGHT / 4 - 15, this.mFont, MenuItem.get(x));
           		
                    Slider(CAMERA_WIDTH * 5/8, spriteY + CAMERA_HEIGHT / 4 - 15, CAMERA_WIDTH * 1/3, x);
            	 
                }
                
                if (menuitemtext == null) menuitemtext = new Text(PADDING,spriteY + CAMERA_HEIGHT / 4 - 15, this.mFont, MenuItem.get(x));
                
        		 iItem++;
        		
        		 
        		 this.mScene.attachChild(menuitemtext);        		 
        		 this.mScene.registerTouchArea(menuitemtext);        		 
   
        		 spriteY += 20 + PADDING+menuitemtext.getHeight();
        	 }
             /*
        	 for (int x = 0; x < MenuItem.size(); x++) {
        		 
        		 //On Touch, save the clicked item in case it's a click and not a scroll.
                 final int itemToLoad = iItem;
        		 
        		 Sprite sprite = new Sprite(spriteX,spriteY + CAMERA_HEIGHT / 4 - 15,columns.get(x)){
        			 
        			 public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
                         iItemClicked = itemToLoad;
                         return false;
        			 }
        		 };
        		 iItem++;
        		
        		 
        		 this.mScene.attachChild(sprite);        		 
        		 this.mScene.registerTouchArea(sprite);        		 
   
        		 spriteY += 20 + PADDING+sprite.getHeight();
			}
        	*/
        	 mMaxX = spriteX - CAMERA_WIDTH;
        	 mMaxY = spriteY - CAMERA_HEIGHT;
        	 
        	 //set the size of the scrollbar
        	 float scrollbarsize = CAMERA_HEIGHT/((mMaxY+CAMERA_HEIGHT)/CAMERA_WIDTH);
        	 scrollBar = new Rectangle(CAMERA_WIDTH - 20, 0, scrollbarsize, 20);
        	 scrollBar.setColor(1,0,0);
        	 this.mScene.attachChild(scrollBar);
        	 
        	 /*
        	 menuleft = new Sprite(0,CAMERA_HEIGHT/2-mMenuLeftTextureRegion.getHeight()/2,mMenuLeftTextureRegion);
        	 menuright = new Sprite(CAMERA_WIDTH-mMenuRightTextureRegion.getWidth(),CAMERA_HEIGHT/2-mMenuRightTextureRegion.getHeight()/2,mMenuRightTextureRegion);
        	 this.mScene.attachChild(menuright);
        	 menuleft.setVisible(false);
        	 this.mScene.attachChild(menuleft);*/
        }
        
        
 
        @Override
        public void onLoadComplete() {
        	 
        }
 
        //Here is where you call the item load.
        private void loadLevel(final int iLevel) {
                if (iLevel != -1) {
                        runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                         	
                                        Toast.makeText(OptionsActivity2.this, "Load Item" + String.valueOf(iLevel), Toast.LENGTH_SHORT).show();
                                        /*
                                        if (iLevel == 1) {
                        					Intent game = new Intent(OptionsActivity2.this, HjarlGameActivity.class); // When clicked, run HjarlGameActivity
                        					startActivity(game); // runs the game intent, which targets the HjarlGameActivity
                                        }
                                        if (iLevel == 2) {
                        					Intent game = new Intent(OptionsActivity2.this, RacerGameActivity.class); // When clicked, run RacerGameActivity
                        					startActivity(game); // runs the game intent, which targets the RacerGameActivity
                                        }
                                        if (iLevel == 3) {
                        					Intent control = new Intent(OptionsActivity2.this, OSControlSetup.class);
                        					startActivity(control);
                                        }
                                        if (iLevel == 4) {
                        					Intent game = new Intent(OptionsActivity2.this, OptionsActivity.class);
                        					startActivity(game);
                                        }
                                        if (iLevel == 5) {
                        					Intent help = new Intent(OptionsActivity2.this, HelpActivity.class);
                        					startActivity(help);
                                        }
                                        if (iLevel == 6) {
                        					Intent help = new Intent(OptionsActivity2.this, MovingBallExample.class);
                        					startActivity(help);
                                        }
                                        if (iLevel == 7) {
                        					Intent help = new Intent(OptionsActivity2.this, MovingBallExample.class);
                        					startActivity(help);
                                        }
                                        if (iLevel == 8) {
                        					Intent help = new Intent(OptionsActivity2.this, MovingBallExample.class);
                        					startActivity(help);
                                        }
                                        */
                                        iItemClicked = -1;
                                }
                        });
                }
        }
        /*
	    @Override
		public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) { 
	    	// Maybe the user decides to use Android buttons instead? Lets try to stop the user from quitting with the back button, by accident.

			if (pKeyCode == KeyEvent.KEYCODE_BACK
					&& pEvent.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being pressed
				showExitDialog(); // Run the showExitDialog.
				return true;
			}
			
			if (pKeyCode == KeyEvent.KEYCODE_DPAD_LEFT
					&& pEvent.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being pressed
				
				
				
				return true;
			}
			
			
			
			
			return super.onKeyDown(pKeyCode, pEvent);
		}
	    */
    	public void Slider(float x, float y, float size, final int i) {
    		
    		final Rectangle sliderbar = new Rectangle(x, y, size, size / 9);
    		//sliderbar.setWidth(size);
    		//sliderbar.setHeight(size / 4);
    		//sliderbar.setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
    		//sliderbar.setAlpha(0.2f);
    		sliderbar.setColor(0.6f, 0.6f, 0.6f);
    		
		    final ChangeableText hudtxt = new ChangeableText(sliderbar.getX() - sliderbar.getWidth() / 3, sliderbar.getY(), mFont, "" + MenuItemValue[i], "100".length());
			mScene.attachChild(hudtxt);
			
			x =	(MenuItemValue[i] * sliderbar.getWidth() / MenuValue[i] ) + sliderbar.getX(); //Move the slider to the curent slider value.
			
    		Rectangle sliderknob = new Rectangle(x, y - size / 36, size / 10, size / 5) {
    			@Override
    			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
    				int MaxValue = MenuValue[i];
    				
    				
                	float TouchX = pSceneTouchEvent.getX();
    				if (TouchX  > sliderbar.getX() + sliderbar.getWidth()) TouchX = sliderbar.getX() + sliderbar.getWidth();
    				if (TouchX  < sliderbar.getX()) TouchX = sliderbar.getX();
    				this.setPosition(TouchX - this.getHeight() / 2,  this.getY() );
    			    float MaxX = sliderbar.getX() + sliderbar.getWidth();
    			    float MinX = sliderbar.getX();
    				MenuItemValue[i] = Math.round(
    						(MaxX - (this.getX()+this.getWidth() / 2)) * MaxValue
    						/ sliderbar.getWidth() );
    				MenuItemValue[i] = Math.round(MaxValue * 1.05f - MenuItemValue[i]);
    				//MenuItemValue[i] = Math.round(MenuItemValue[i] / 20);

					hudtxt.reset();
					hudtxt.setText("" + MenuItemValue[i] + "");

    				/*scale[i] = 2 - ((this.getY()+this.getHeightScaled() / 2) / CAMERA_HEIGHT) * 2;
    				
    				scale[f] = scale[f] * 20;
    				scale[f] = Math.round(scale[f]);
    				scale[f] = scale[f] / 20;
    				*/
    				//hudtxt.setText("Value: " + MenuItemValue[i] + "");
    				//hudtxt.setPosition(this.getX(),this.getY());
    				
    				
    				//hudtxt.setPosition(this.getX() - 20,this.getY());
    				
    				
    				if (pSceneTouchEvent.getAction() == TouchEvent.ACTION_UP) {
    					hudtxt.reset();
    					hudtxt.setText("" + MenuItemValue[i] + "");
    					
    					//pSceneTouchEvent.set(control[f].getX() + control[f].getWidthScaled() / 2, control[f].getY() + control[f].getHeight() * (2 - scale[f])/ 2);
    					
    					//control[f].onAreaTouched(pSceneTouchEvent, control[f].getX() + control[f].getWidthScaled() / 2, control[f].getY() + control[f].getHeight() * (2 - scale[f])/ 2);
    					
    				}
    			
    				//control[f].setScale(scale[f]);
    				
    				return true;
    			}
    		};
    		//sliderknob.setWidth(CAMERA_WIDTH / 10);
    		//sliderknob.setHeight(CAMERA_WIDTH / 20);
    		sliderknob.setColor(0, 0, 0);
    		
    		//this.sliderbar = new Sprite(CAMERA_WIDTH - CAMERA_WIDTH / 20, 0, this.sliderTextureRegion);


    		mScene.attachChild(sliderbar);
    		mScene.attachChild(sliderknob);
    		mScene.registerTouchArea(sliderknob);
    		
    	}
        
	    @Override
		public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) { 
	    	// Maybe the user decides to use Android buttons instead? Lets try to stop the user from quitting with the back button, by accident.

			if (pKeyCode == KeyEvent.KEYCODE_BACK
					&& pEvent.getAction() == KeyEvent.ACTION_DOWN) { // Check if the back button is being pressed
				
				boolean sfx = false; boolean music = false; boolean sprite = false; boolean vibrate = false;
				int controlpads = MenuItemValue[6]; int buttons = MenuItemValue[7]; int sfxvol = MenuItemValue[5]; int musvol = MenuItemValue[3];
				if (MenuValue[1] == 1) sprite = true;
				if (MenuValue[2] == 1) music = true;
				if (MenuValue[4] == 1) sfx = true;
				if (MenuValue[8] == 1) vibrate = true;
				
				options.save(sfx, music, sprite, vibrate, controlpads, buttons, sfxvol, musvol);
				
				
				OptionsActivity2.this.finish(); // if yes is clicked, close this class. If this class had been opened by another class, we would return to that class.
				return true;
			}
			
			return super.onKeyDown(pKeyCode, pEvent);
		}
        
	    public void showExitDialog() { // Here a showExitDialog is prepared. Its a kind of submenu, but since it is very simple its all done without XML
	    	AlertDialog.Builder builder = new AlertDialog.Builder(OptionsActivity2.this); // Making an AlerDialog, its an Android feature
			builder.setMessage("Are you sure you want to exit?")
					.setCancelable(false)
					.setTitle("EXIT")
					.setPositiveButton("Yes",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int id) {
									boolean sfx = false; boolean music = false; boolean sprite = false; boolean vibrate = false;
									int controlpads = MenuItemValue[6]; int buttons = MenuItemValue[7]; int sfxvol = MenuItemValue[5]; int musvol = MenuItemValue[3];
									if (MenuValue[1] == 1) sprite = true;
									if (MenuValue[2] == 1) music = true;
									if (MenuValue[4] == 1) sfx = true;
									if (MenuValue[8] == 1) vibrate = true;

									options.save(sfx, music, sprite, vibrate, controlpads, buttons, sfxvol, musvol);
									
									
									OptionsActivity2.this.finish(); // if yes is clicked, close this class. If this class had been opened by another class, we would return to that class.
								}
							})
							
					.setNegativeButton("No", new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int id) {
							dialog.cancel(); // Of the NO choice is clicked, we cancel the AlertDialog and go back to Menuactivity2
						}
					});

			AlertDialog alert = builder.create(); // This takes the AlertDialog and prepares it
			alert.setIcon(R.drawable.icon); // Puts the application icon in the drawable folder into the dialog
			alert.show(); // shows the alert dialog
	    
	    }
}
 