package dk.dionysus.hjarl;

import javax.microedition.khronos.opengles.GL10;

import dk.dionysus.hjarl.Controls;
import dk.dionysus.hjarl.Options;
import dk.dionysus.hjarl.Highscore;
import me.trifunovic.spaceassault.game.hud.HudScore;

import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.SingleSceneSplitScreenEngine;
import org.anddev.andengine.engine.camera.BoundCamera;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.camera.hud.HUD;
import org.anddev.andengine.engine.camera.hud.controls.AnalogOnScreenControl;
import org.anddev.andengine.engine.camera.hud.controls.AnalogOnScreenControl.IAnalogOnScreenControlListener;
import org.anddev.andengine.engine.camera.hud.controls.BaseOnScreenControl;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.primitive.Rectangle;
import org.anddev.andengine.entity.scene.CameraScene;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.background.ColorBackground;
import org.anddev.andengine.entity.shape.Shape;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.entity.sprite.TiledSprite;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.extension.input.touch.controller.MultiTouch;
import org.anddev.andengine.extension.input.touch.controller.MultiTouchController;
import org.anddev.andengine.extension.input.touch.exception.MultiTouchException;
import org.anddev.andengine.extension.physics.box2d.FixedStepPhysicsWorld;
import org.anddev.andengine.extension.physics.box2d.PhysicsConnector;
import org.anddev.andengine.extension.physics.box2d.PhysicsFactory;
import org.anddev.andengine.extension.physics.box2d.PhysicsWorld;
import org.anddev.andengine.extension.physics.box2d.util.Vector2Pool;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.ui.activity.BaseGameActivity;
import org.anddev.andengine.util.MathUtils;

import android.view.KeyEvent;
import android.widget.Toast;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.BodyDef.BodyType;
import com.badlogic.gdx.physics.box2d.FixtureDef;

/**
 * (c) 2010 Nicolas Gramlich
 * (c) 2011 Zynga
 *
 * @author Nicolas Gramlich
 * @since 22:43:20 - 15.07.2010
 * 
 * @author Kasper Olesen
 * @since 18:29:20 - 19.12.2011
 */

public class RacerGameActivity  extends BaseGameActivity {
	// ===========================================================
	// Constants
	// ===========================================================

	private static final int RACETRACK_WIDTH = 64;

	private static final int OBSTACLE_SIZE = 16;
	private static final int CAR_SIZE = 16;

	private static final int CAMERA_WIDTH = RACETRACK_WIDTH * 5;
	
	private static final int CAMERA_HEIGHT = RACETRACK_WIDTH * 3;
	

	// ===========================================================
	// Fields
	// ===========================================================

	private Camera mCamera;
	private Camera mChaseCamera;

	private BitmapTextureAtlas mVehiclesTexture;
	private TiledTextureRegion mVehiclesTextureRegion;

	private BitmapTextureAtlas mBoxTexture;
	private TextureRegion mBoxTextureRegion;

	private BitmapTextureAtlas mRacetrackTexture;
	private TextureRegion mRacetrackStraightTextureRegion;
	private TextureRegion mRacetrackCurveTextureRegion;

	private BitmapTextureAtlas mOnScreenControlTexture;
	private TextureRegion mOnScreenControlBaseTextureRegion;
	private TextureRegion mOnScreenControlKnobTextureRegion;

	private BitmapTextureAtlas PauseButtonTextureRegion;
	private TextureRegion mPausedTextureRegion;
	private CameraScene mPauseScene;
	
	
	private Scene mScene;

	private PhysicsWorld mPhysicsWorld;

	private Body mCarBody;
	private TiledSprite mCar;
	private Body mCarBody2;
	private TiledSprite mCar2;

	int CarX1 = 0; int CarY1 = 0; int CarX2 = 0; int CarY2 = 0;
	
	// ===========================================================
	// Constructors
	// ===========================================================

	// ===========================================================
	// Getter & Setter
	// ===========================================================
	public static final HudScore score = new HudScore();
	public static Options options;
	public static Controls controls;
	
	int ControlKeyAction1[];
	int ControlKeyAction2[];
	int ControlKeyAction3[];
	int ControlKeyAction4[];

	
	HUD hud = new HUD();
	HUD hud2 = new HUD();
	
	// ===========================================================
	// Methods for/from SuperClass/Interfaces
	// ===========================================================

	
	public Engine onLoadEngine() {
		options = new Options(RacerGameActivity.this);
		controls = new Controls(RacerGameActivity.this);
				
		//this.mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
		//return new Engine(new EngineOptions(true, ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT), this.mCamera));
				
		Toast.makeText(this, "Two cameras.", Toast.LENGTH_LONG).show();
		this.mCamera = new BoundCamera(0, 0, CAMERA_WIDTH / 2 , CAMERA_HEIGHT, 0, CAMERA_WIDTH, 0, CAMERA_HEIGHT);
		this.mChaseCamera = new BoundCamera(0, 0, CAMERA_WIDTH / 2, CAMERA_HEIGHT, 0, CAMERA_WIDTH, 0, CAMERA_HEIGHT);
		final EngineOptions engineOptions = new EngineOptions(true, ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(CAMERA_WIDTH * 2, CAMERA_HEIGHT * 2), this.mCamera);
		engineOptions.getTouchOptions().setRunOnUpdateThread(true);
		mCamera.setHUD(this.hud);
		mChaseCamera.setHUD(this.hud2);
		
		final Engine engine = new SingleSceneSplitScreenEngine(engineOptions, this.mChaseCamera);
		
		
		
		try {
			if(MultiTouch.isSupported(this)) {
				engine.setTouchController(new MultiTouchController());
			} else {
				Toast.makeText(this, "Sorry your device does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)\n\nControls are placed at different vertical locations.", Toast.LENGTH_LONG).show();
			}
		} catch (final MultiTouchException e) {
			Toast.makeText(this, "Sorry your Android Version does NOT support MultiTouch!\n\n(Falling back to SingleTouch.)\n\nControls are placed at different vertical locations.", Toast.LENGTH_LONG).show();
		}
		
		return engine;
		
		
		
		
	}

	
	public void onLoadResources() {
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");

		this.mVehiclesTexture = new BitmapTextureAtlas(128, 16, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mVehiclesTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.mVehiclesTexture, this, "vehicles.png", 0, 0, 6, 1);

		this.mRacetrackTexture = new BitmapTextureAtlas(128, 256, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mRacetrackStraightTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mRacetrackTexture, this, "racetrack_straight.png", 0, 0);
		this.mRacetrackCurveTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mRacetrackTexture, this, "racetrack_curve.png", 0, 128);

		this.mOnScreenControlTexture = new BitmapTextureAtlas(256, 128, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mOnScreenControlBaseTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_base.png", 0, 0);
		this.mOnScreenControlKnobTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOnScreenControlTexture, this, "onscreen_control_knob.png", 128, 0);

		this.mBoxTexture = new BitmapTextureAtlas(32, 32, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mBoxTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBoxTexture, this, "box.png", 0, 0);
		
		this.PauseButtonTextureRegion = new BitmapTextureAtlas(256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mPausedTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.PauseButtonTextureRegion, this, "buttons/PAUSE.png", 0, 0);

		this.mEngine.getTextureManager().loadTextures(this.mVehiclesTexture, this.mRacetrackTexture, this.mOnScreenControlTexture, this.mBoxTexture);
	}

	
	public Scene onLoadScene() {
		
		ControlKeyAction1 = new int[10];
		ControlKeyAction2 = new int[10];
		ControlKeyAction3 = new int[10];
		ControlKeyAction4 = new int[10];

		
		this.mEngine.registerUpdateHandler(new FPSLogger());

		this.mScene = new Scene();
		this.mScene.setBackground(new ColorBackground(0, 0, 0));
		
		this.mPauseScene = new CameraScene(this.mCamera);
		/* Make the 'PAUSED'-label centered on the camera. */
		final Sprite pausedSprite = new Sprite(CAMERA_WIDTH / 2 - this.mPausedTextureRegion.getWidth() / 2, CAMERA_HEIGHT / 2 - this.mPausedTextureRegion.getHeight() / 2, this.mPausedTextureRegion);
		this.mPauseScene.attachChild(pausedSprite);
		/* Makes the paused Game look through. */
		this.mPauseScene.setBackgroundEnabled(false);
		
		this.mPhysicsWorld = new FixedStepPhysicsWorld(30, new Vector2(0, 0), false, 8, 1);

		/*
		ControlKeyAction1[0] = 19; //controls.getKey(0, 1);
		ControlKeyAction2[0] = 20; //controls.getKey(0, 2);
		ControlKeyAction3[0] = 21; //controls.getKey(0, 3);
		ControlKeyAction4[0] = 22; //controls.getKey(0, 4);
		*/
		
		for (int i = 0; i < 10; i++) {
			/*
			int s = 64;
			if (i < 4) s = 128;
			scale[i] = controls.getScale(i);
			
			ControlX[i] = controls.getX(i) * (CAMERA_WIDTH - s * scale[i]) / 100;;
			
			ControlY[i] = controls.getY(i) / 100 * (CAMERA_HEIGHT - s * scale[i]);
			
			ControlY[i] = ControlY[i] - s * (1 - scale[i]);
			*/
			ControlKeyAction1[i] = controls.getKey(i, 1);
			ControlKeyAction2[i] = controls.getKey(i, 2);
			ControlKeyAction3[i] = controls.getKey(i, 3);
			ControlKeyAction4[i] = controls.getKey(i, 4);
		}
		
		this.initRacetrack();
		this.initRacetrackBorders();
		this.initCar();		
		this.initObstacles();
		this.initOnScreenControls();

		this.mScene.registerUpdateHandler(this.mPhysicsWorld);
		

		

		return this.mScene;
	}

	
	public void onLoadComplete() {

	}

	// ===========================================================
	// Methods
	// ===========================================================

	private void initOnScreenControls() {
		
		Controls controls = new Controls(RacerGameActivity.this);
		
		Highscore score = new Highscore(RacerGameActivity.this);
		
		float ControlSize = controls.getScale(0) / 4;		
		float ControlX = controls.getX(0) * (CAMERA_WIDTH / 2 - 128 * ControlSize)  / 100;
		float ControlY = controls.getY(0) / 100 *  (CAMERA_HEIGHT - 128 * ControlSize);
		
		ControlY = ControlY - 128 * (1 - ControlSize);
		
		// Toast for debugging
		Toast.makeText(RacerGameActivity.this, "Scale:" + ControlSize + " Y: " + ControlY, Toast.LENGTH_SHORT).show();
		
		//ControlX = 0;
		//ControlY = CAMERA_HEIGHT - this.mOnScreenControlBaseTextureRegion.getHeight() - ControlY;
		//ControlSize = 75; 
		
		final AnalogOnScreenControl analogOnScreenControl = new AnalogOnScreenControl(ControlX, ControlY, this.mCamera, this.mOnScreenControlBaseTextureRegion, this.mOnScreenControlKnobTextureRegion, 0.1f, new IAnalogOnScreenControlListener() {
			
			public void onControlChange(final BaseOnScreenControl pBaseOnScreenControl, float pValueX, float pValueY) {
				final Body carBody = RacerGameActivity.this.mCarBody;


				//if (CarX1 == -1 || CarX1 == 1) pValueX = CarX1;
				//if (CarY1 == -1 || CarY1 == 1) pValueY = CarY1;
				if (CarX1 != 0) pValueX = CarX1;
				if (CarY1 != 0) pValueY = CarY1;
				
				
				final Vector2 velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 5);
				carBody.setLinearVelocity(velocity);
				Vector2Pool.recycle(velocity);

				final float rotationInRad = (float)Math.atan2(-pValueX, pValueY);
				carBody.setTransform(carBody.getWorldCenter(), rotationInRad);

				RacerGameActivity.this.mCar.setRotation(MathUtils.radToDeg(rotationInRad));
			}

			
			public void onControlClick(final AnalogOnScreenControl pAnalogOnScreenControl) {
				/* Nothing. */
			}
		});
		analogOnScreenControl.getControlBase().setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		analogOnScreenControl.getControlBase().setAlpha(0.5f);
		analogOnScreenControl.getControlBase().setScaleCenter(0, 128);
		
		float size = ControlSize;
		// Toast for debugging
		Toast.makeText(RacerGameActivity.this, "Scale:" + size, Toast.LENGTH_SHORT).show();
		//size = 0.75f;
		
		analogOnScreenControl.getControlBase().setScale(size);
		analogOnScreenControl.getControlKnob().setScale(size);
		
		analogOnScreenControl.refreshControlKnobPosition();

		this.hud.setChildScene(analogOnScreenControl);
		
		
		ControlSize = controls.getScale(4) / 4;
		ControlX = controls.getX(4) * (CAMERA_WIDTH / 2 - 64 * ControlSize)  / 100;
		ControlY = controls.getY(4) / 100 *  (CAMERA_HEIGHT - 64 * ControlSize);
		ControlY = ControlY - 64 * (1 - ControlSize);
		
		Sprite Button = new Sprite(ControlX, ControlY, this.mOnScreenControlKnobTextureRegion);
		Button.setScaleCenter(0, 64);
		Button.setScale(ControlSize);
		this.hud.attachChild(Button);
		
		
		// ******** Second camera controls *********
		
		ControlSize = controls.getScale(1) / 4;		
		ControlX = controls.getX(1) * (CAMERA_WIDTH / 2 - 128 * ControlSize)  / 100;
		ControlY = controls.getY(1) / 100 *  (CAMERA_HEIGHT - 128 * ControlSize);
		
		ControlY = ControlY - 128 * (1 - ControlSize);
		
		// Toast for debugging
		Toast.makeText(RacerGameActivity.this, "Scale:" + ControlSize + " Y: " + ControlY, Toast.LENGTH_SHORT).show();
		
		//ControlX = 0;
		//ControlY = CAMERA_HEIGHT - this.mOnScreenControlBaseTextureRegion.getHeight() - ControlY;
		//ControlSize = 75; 
		
		final AnalogOnScreenControl analogOnScreenControl2 = new AnalogOnScreenControl(ControlX, ControlY, this.mChaseCamera, this.mOnScreenControlBaseTextureRegion, this.mOnScreenControlKnobTextureRegion, 0.1f, new IAnalogOnScreenControlListener() {
			
			public void onControlChange(final BaseOnScreenControl pBaseOnScreenControl, float pValueX, float pValueY) {
				final Body carBody = RacerGameActivity.this.mCarBody2;

				if (CarX2 != 0) pValueX = CarX2;
				if (CarY2 != 0) pValueY = CarY2;
				
				
				final Vector2 velocity = Vector2Pool.obtain(pValueX * 5, pValueY * 5);
				carBody.setLinearVelocity(velocity);
				Vector2Pool.recycle(velocity);

				final float rotationInRad = (float)Math.atan2(-pValueX, pValueY);
				carBody.setTransform(carBody.getWorldCenter(), rotationInRad);

				RacerGameActivity.this.mCar2.setRotation(MathUtils.radToDeg(rotationInRad));
			}

			
			public void onControlClick(final AnalogOnScreenControl pAnalogOnScreenControl) {
				/* Nothing. */
			}
		});
		analogOnScreenControl2.getControlBase().setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		analogOnScreenControl2.getControlBase().setAlpha(0.5f);
		analogOnScreenControl2.getControlBase().setScaleCenter(0, 128);
		
		size = ControlSize;

		//size = 0.75f;
		
		analogOnScreenControl2.getControlBase().setScale(size);
		analogOnScreenControl2.getControlKnob().setScale(size);
		
		analogOnScreenControl2.refreshControlKnobPosition();

		this.hud2.setChildScene(analogOnScreenControl2);
		
		
		ControlSize = controls.getScale(5) / 4;
		ControlX = controls.getX(5) * (CAMERA_WIDTH / 2 - 64 * ControlSize)  / 100;
		ControlY = controls.getY(5) / 100 *  (CAMERA_HEIGHT - 64 * ControlSize);
		ControlY = ControlY - 64 * (1 - ControlSize);
		
		Sprite Button2 = new Sprite(ControlX, ControlY, this.mOnScreenControlKnobTextureRegion);
		Button2.setScaleCenter(0, 64);
		Button2.setScale(ControlSize);
		this.hud2.attachChild(Button2);
		
		
		
	}

	private void initCar() {
		this.mCar = new TiledSprite(20, 20, CAR_SIZE, CAR_SIZE, this.mVehiclesTextureRegion);
		this.mCar.setCurrentTileIndex(0);

		final FixtureDef carFixtureDef = PhysicsFactory.createFixtureDef(1, 0.5f, 0.5f);
		this.mCarBody = PhysicsFactory.createBoxBody(this.mPhysicsWorld, this.mCar, BodyType.DynamicBody, carFixtureDef);

		this.mPhysicsWorld.registerPhysicsConnector(new PhysicsConnector(this.mCar, this.mCarBody, true, false));

		this.mScene.attachChild(this.mCar);
		this.mCamera.setChaseEntity(mCar);
		
		this.mCar2 = new TiledSprite(300, 20, CAR_SIZE, CAR_SIZE, this.mVehiclesTextureRegion);
		this.mCar2.setCurrentTileIndex(0);

		this.mCarBody2 = PhysicsFactory.createBoxBody(this.mPhysicsWorld, this.mCar2, BodyType.DynamicBody, carFixtureDef);

		this.mPhysicsWorld.registerPhysicsConnector(new PhysicsConnector(this.mCar2, this.mCarBody2, true, false));

		this.mScene.attachChild(this.mCar2);
		this.mChaseCamera.setChaseEntity(mCar2);
		
	}

	private void initObstacles() {
		this.addObstacle(CAMERA_WIDTH / 2, RACETRACK_WIDTH / 2);
		this.addObstacle(CAMERA_WIDTH / 2, RACETRACK_WIDTH / 2);
		this.addObstacle(CAMERA_WIDTH / 2, CAMERA_HEIGHT - RACETRACK_WIDTH / 2);
		this.addObstacle(CAMERA_WIDTH / 2, CAMERA_HEIGHT - RACETRACK_WIDTH / 2);
	}

	private void addObstacle(final float pX, final float pY) {
		final Sprite box = new Sprite(pX, pY, OBSTACLE_SIZE, OBSTACLE_SIZE, this.mBoxTextureRegion);

		final FixtureDef boxFixtureDef = PhysicsFactory.createFixtureDef(0.1f, 0.5f, 0.5f);
		Body boxBody = PhysicsFactory.createBoxBody(this.mPhysicsWorld, box, BodyType.DynamicBody, boxFixtureDef);
		boxBody.setLinearDamping(10);
		boxBody.setAngularDamping(10);

		this.mPhysicsWorld.registerPhysicsConnector(new PhysicsConnector(box, boxBody, true, true));

		this.mScene.attachChild(box);
		
		
		final PhysicsConnector facePhysicsConnector = this.mPhysicsWorld.getPhysicsConnectorManager().findPhysicsConnectorByShape(box);

		this.mPhysicsWorld.unregisterPhysicsConnector(facePhysicsConnector);
		this.mPhysicsWorld.destroyBody(facePhysicsConnector.getBody());

		this.mScene.unregisterTouchArea(box);
		this.mScene.detachChild(box);
		
		System.gc();
		
		boxBody = PhysicsFactory.createBoxBody(this.mPhysicsWorld, box, BodyType.DynamicBody, boxFixtureDef);
		boxBody.setLinearDamping(10);
		boxBody.setAngularDamping(10);

		this.mPhysicsWorld.registerPhysicsConnector(new PhysicsConnector(box, boxBody, true, true));

		this.mScene.attachChild(box);
		
	}

	private void initRacetrack() {
		/* Straights. */
		{
			final TextureRegion racetrackHorizontalStraightTextureRegion = this.mRacetrackStraightTextureRegion.clone();
			racetrackHorizontalStraightTextureRegion.setWidth(3 * this.mRacetrackStraightTextureRegion.getWidth());

			final TextureRegion racetrackVerticalStraightTextureRegion = this.mRacetrackStraightTextureRegion;

			/* Top Straight */
			this.mScene.attachChild(new Sprite(RACETRACK_WIDTH, 0, 3 * RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackHorizontalStraightTextureRegion));
			/* Bottom Straight */
			this.mScene.attachChild(new Sprite(RACETRACK_WIDTH, CAMERA_HEIGHT - RACETRACK_WIDTH, 3 * RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackHorizontalStraightTextureRegion));

			/* Left Straight */
			final Sprite leftVerticalStraight = new Sprite(0, RACETRACK_WIDTH, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackVerticalStraightTextureRegion);
			leftVerticalStraight.setRotation(90);
			this.mScene.attachChild(leftVerticalStraight);
			/* Right Straight */
			final Sprite rightVerticalStraight = new Sprite(CAMERA_WIDTH - RACETRACK_WIDTH, RACETRACK_WIDTH, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackVerticalStraightTextureRegion);
			rightVerticalStraight.setRotation(90);
			this.mScene.attachChild(rightVerticalStraight);
		}

		/* Edges */
		{
			final TextureRegion racetrackCurveTextureRegion = this.mRacetrackCurveTextureRegion;

			/* Upper Left */
			final Sprite upperLeftCurve = new Sprite(0, 0, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackCurveTextureRegion);
			upperLeftCurve.setRotation(90);
			this.mScene.attachChild(upperLeftCurve);

			/* Upper Right */
			final Sprite upperRightCurve = new Sprite(CAMERA_WIDTH - RACETRACK_WIDTH, 0, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackCurveTextureRegion);
			upperRightCurve.setRotation(180);
			this.mScene.attachChild(upperRightCurve);

			/* Lower Right */
			final Sprite lowerRightCurve = new Sprite(CAMERA_WIDTH - RACETRACK_WIDTH, CAMERA_HEIGHT - RACETRACK_WIDTH, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackCurveTextureRegion);
			lowerRightCurve.setRotation(270);
			this.mScene.attachChild(lowerRightCurve);

			/* Lower Left */
			final Sprite lowerLeftCurve = new Sprite(0, CAMERA_HEIGHT - RACETRACK_WIDTH, RACETRACK_WIDTH, RACETRACK_WIDTH, racetrackCurveTextureRegion);
			this.mScene.attachChild(lowerLeftCurve);
		}
	}


	private void initRacetrackBorders() {
		final Shape bottomOuter = new Rectangle(0, CAMERA_HEIGHT - 2, CAMERA_WIDTH, 2);
		final Shape topOuter = new Rectangle(0, 0, CAMERA_WIDTH, 2);
		final Shape leftOuter = new Rectangle(0, 0, 2, CAMERA_HEIGHT);
		final Shape rightOuter = new Rectangle(CAMERA_WIDTH - 2, 0, 2, CAMERA_HEIGHT);

		final Shape bottomInner = new Rectangle(RACETRACK_WIDTH, CAMERA_HEIGHT - 2 - RACETRACK_WIDTH, CAMERA_WIDTH - 2 * RACETRACK_WIDTH, 2);
		final Shape topInner = new Rectangle(RACETRACK_WIDTH, RACETRACK_WIDTH, CAMERA_WIDTH - 2 * RACETRACK_WIDTH, 2);
		final Shape leftInner = new Rectangle(RACETRACK_WIDTH, RACETRACK_WIDTH, 2, CAMERA_HEIGHT - 2 * RACETRACK_WIDTH);
		final Shape rightInner = new Rectangle(CAMERA_WIDTH - 2 - RACETRACK_WIDTH, RACETRACK_WIDTH, 2, CAMERA_HEIGHT - 2 * RACETRACK_WIDTH);

		final FixtureDef wallFixtureDef = PhysicsFactory.createFixtureDef(0, 0.5f, 0.5f);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, bottomOuter, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, topOuter, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, leftOuter, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, rightOuter, BodyType.StaticBody, wallFixtureDef);

		PhysicsFactory.createBoxBody(this.mPhysicsWorld, bottomInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, topInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, leftInner, BodyType.StaticBody, wallFixtureDef);
		PhysicsFactory.createBoxBody(this.mPhysicsWorld, rightInner, BodyType.StaticBody, wallFixtureDef);

		this.mScene.attachChild(bottomOuter);
		this.mScene.attachChild(topOuter);
		this.mScene.attachChild(leftOuter);
		this.mScene.attachChild(rightOuter);

		this.mScene.attachChild(bottomInner);
		this.mScene.attachChild(topInner);
		this.mScene.attachChild(leftInner);
		this.mScene.attachChild(rightInner);
	}

	public boolean onKeyUp(final int pKeyCode, final KeyEvent pEvent) {

		if(pKeyCode == ControlKeyAction1[0] && CarY1 == -1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarY1 = 0;
		}
		if(pKeyCode == ControlKeyAction2[0] && CarY1 == 1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarY1 = 0;
		}
		
		if(pKeyCode == ControlKeyAction3[0] && CarX1 == -1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarX1 = 0;
		}
		if(pKeyCode == ControlKeyAction4[0] && CarX1 == 1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarX1 = 0;
		}
		
		
		if(pKeyCode == ControlKeyAction1[1] && CarY2 == -1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarY2 = 0;
		}
		if(pKeyCode == ControlKeyAction2[1] && CarY2 == 1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarY2 = 0;
		}
		
		if(pKeyCode == ControlKeyAction3[1] && CarX2 == -1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarX2 = 0;
		}
		if(pKeyCode == ControlKeyAction4[1] && CarX2 == 1 && pEvent.getAction() == KeyEvent.ACTION_UP) {
			CarX2 = 0;
		}
		
		return false;
	}
	
	
	@Override
	public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) {
		
		//this.sendDownUpKeyEvents(KeyEvent.KEYCODE_C);
		
		/*
		if(pKeyCode != 182)	{
			//KeyEvent.changeFlags(pEvent, 182);
			return super.onKeyDown(182, pEvent);
		}
		*/
		
		if(pKeyCode == KeyEvent.KEYCODE_MENU && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			if(this.mEngine.isRunning()) {
				HjarlGameActivity.mScene.setChildScene(this.mPauseScene, false, true, true);
				this.mEngine.stop();
			} else {
				HjarlGameActivity.mScene.clearChildScene();
				//this.initOnScreenControls();
				this.mEngine.start();
			}
			return true;
		}


		//int key = HjarlGameActivity.controls.getKey(4, 1);
		if(pKeyCode == ControlKeyAction1[4] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			
			//RacerGameActivity.this.throwHardware(CAMERA_WIDTH + 5, CAMERA_HEIGHT / 2);

		}

		if(pKeyCode == ControlKeyAction1[0]) {
			CarY1 = -1;
		}
		if(pKeyCode == ControlKeyAction2[0]) {
			CarY1 = 1;
		}
		
		if(pKeyCode == ControlKeyAction1[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarY1 = -1;

		}
		if(pKeyCode == ControlKeyAction2[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarY1 = 1;

		}
		
		if(pKeyCode == ControlKeyAction3[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarX1 = -1;

		}
		if(pKeyCode == ControlKeyAction4[0] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarX1 = 1;

		}
		
		
		if(pKeyCode == ControlKeyAction1[1] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarY2 = -1;

		}
		if(pKeyCode == ControlKeyAction2[1] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarY2 = 1;
		}
		
		if(pKeyCode == ControlKeyAction3[1] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarX2 = -1;

		}
		if(pKeyCode == ControlKeyAction4[1] && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			CarX2 = 1;
		}

		for (int i = 0; i < 10; i++) {
			if(pKeyCode == ControlKeyAction1[i] && pEvent.getAction() == KeyEvent.ACTION_DOWN) return true;
			if(pKeyCode == ControlKeyAction2[i] && pEvent.getAction() == KeyEvent.ACTION_DOWN) return true;
			if(pKeyCode == ControlKeyAction3[i] && pEvent.getAction() == KeyEvent.ACTION_DOWN) return true;
			if(pKeyCode == ControlKeyAction4[i] && pEvent.getAction() == KeyEvent.ACTION_DOWN) return true;
		}

		
	
		return super.onKeyDown(pKeyCode, pEvent);
	}
	// ===========================================================
	// Inner and Anonymous Classes
	// ===========================================================
}
